C 14/03/2000 THE GRAIN BOUNDARY stuff is removed and only intragranular 
C precipitates are dealt with. The Grain boundary things can be found in
C debut0_6.f
C
C The structure has been modified to have controlling components for each 
C kind of precipitates. CCT(10,20) first precipitate, second component
C Further modification: parameter for the number of precipitate and the 
C dimension of the arrays with time step.. 
C
C 31/03 modifications in the diffusion coefficient calculation
C contains subroutines to calculate D matrix. Not working yet
C
C     05-06-99 Trying to use dislocation nucleation
C 05/02/01 Snapshot for radius of pcp 1
C 12/02/01 a new attempt to increase the maximum number of steps
C 16/02/01 correcting the cos cube in grain boundary nucleation
C          including triple point nucleation for sigma.
C          calculate tie-line only if gives more than one controlling component
C     adding alogarithmic increment rather than linear.
C     log seems not appropriate, trying square root.
C
C This is based on debut060901 from devel3
C Orginal includes activity of carbon as controlling growth rate. 
C This version is corrected for reading of precipitate_data and try to include 
C dissolution of precipitates
C added indice to NCCT number of controlling component kept for each pcp


      PROGRAM DEBUT

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)
      
      INTEGER NLINES,I
      CHARACTER*50 LINE(15)

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
      INTEGER NPCP

      DOUBLE PRECISION NV(MAXPCP),GTR(MAXPCP)

      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT
      DOUBLE PRECISION POWER

      DOUBLE PRECISION VOLINC(MAXPCP,MAXTIM),VFRAC(MAXPCP)
      DOUBLE PRECISION VP(MAXPCP),VINIT

      DOUBLE PRECISION MODIF(MAXPCP,MAXCPT)

      DOUBLE PRECISION SURINC(MAXPCP),SUROCC,SURFAC

      DOUBLE PRECISION TEMP,COMPO(MAXCPT)

      INTEGER NCELL(2,MAXPCP),DATAST(MAXPCP)
      DOUBLE PRECISION LATPAR(MAXPCP,5),SIGMA(MAXPCP)

      DOUBLE PRECISION VMOL(2,MAXPCP),LATICE(MAXPCP)

      INTEGER NCCT(MAXPCP),CCT(MAXPCP,MAXCPT)
      DOUBLE PRECISION DIFFU(MAXCPT)

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT)
      DOUBLE PRECISION CBA(MAXCPT),CAVERN(MAXCPT),VG(MAXPCP)

      DOUBLE PRECISION CABB(MAXPCP,MAXCPT),CBAA(MAXPCP,MAXCPT)
      INTEGER ENDTIM(MAXPCP)

      DOUBLE PRECISION SPHGRO(2,500),PLAGRO(2,500)

      DOUBLE PRECISION DMAT(6,6)

      COMMON / MENU / NLINES,LINE
      COMMON / PHASES / MATRIX,PRECIP,NPCP
      COMMON / NUCLEA / NV,GTR
      COMMON / GROWTH / NUCLEI,RADII,DT,POWER
      COMMON / GROW2 / VINIT,VOLINC,VFRAC,VP
      COMMON / GROW3 / MODIF
      COMMON / GBGROW / SURINC,SURFAC,SUROCC
      COMMON / DATA1 / TEMP,COMPO
      COMMON / DATA2 / NCELL,LATPAR,SIGMA,DATAST
      COMMON / DATA3 / VMOL,LATICE
      COMMON / CTROL / NCCT,CCT,DIFFU
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG
      COMMON / PRECAL / SPHGRO,PLAGRO
      COMMON / DISSO / CABB,CBAA,ENDTIM


      CALL PREP_TABLE (SPHGRO,'spheregrowth.out')
      CALL PREP_TABLE (PLAGRO,'planargrowth.out')
c$$$      DO 10 I=1,499
c$$$         WRITE(*,*) 'Omega: ',DBLE(I)*0.002,' and S:',SPHGRO(1,I),
c$$$     & 'S planar: ', PLAGRO(1,I)
c$$$ 10      CONTINUE
      WRITE(*,*) 'Power for time scale ? (default 0.5)'
      READ (*,*) POWER
      
C      PAUSE
      CALL FIRST_CHOICE()
      CALL MOLAR_VOLUME()
      CALL SET_MATPRE()
      CALL INIT_CALCUL()
      CALL DEFINE_ZERO()
      CALL SET_DIFFU()
C      CALL JACOMU(CAVERN,TEMP,JACO)
C      CALL CALC_DIFFU_II(DMAT)
      CALL SET_COMPONENT_CONTROL()
      CALL GBGROWTH()

      END

C Experimental

      SUBROUTINE GBGROWTH()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER NOSTEP,PCP,X,INIT_PHASE_NO
      INTEGER PCPFLAG(MAXPCP),GLOBFG,K
      CHARACTER*40 FILEN

      DOUBLE PRECISION TIME,LENGTH,POWER
      DOUBLE PRECISION DGT,DGNUC,RATE(MAXPCP),GT(MAXPCP),GTR(MAXCPT)
      DOUBLE PRECISION THETA,D
      DOUBLE PRECISION NV(MAXPCP)

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
      INTEGER NPCP
      INTEGER NLINES
      CHARACTER *50 LINE(15)

      DOUBLE PRECISION NV(MAXPCP),GTR(MAXPCP)
      
      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT
      DOUBLE PRECISION POWER

      DOUBLE PRECISION VOLINC(MAXPCP,MAXTIM),VFRAC(MAXPCP),VP(MAXPCP)
      DOUBLE PRECISION VINIT

      DOUBLE PRECISION SURINC(MAXPCP),SURFAC,SUROCC

      INTEGER NCELL(2,MAXPCP),DATAST(MAXPCP)
      DOUBLE PRECISION LATPAR(MAXPCP,5),SIGMA(MAXPCP)
      DOUBLE PRECISION TEMP,COMPO(MAXCPT)
      
      DOUBLE PRECISION VMOL(2,MAXPCP),LATICE(MAXPCP)

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG(MAXPCP)

      DOUBLE PRECISION CABB(MAXPCP,MAXCPT),CBAA(MAXPCP,MAXCPT)
      INTEGER ENDTIM(MAXPCP)

      COMMON / MENU / NLINES,LINE
      COMMON / PHASES / MATRIX,PRECIP,NPCP
      COMMON / NUCLEA / NV,GTR
      COMMON / GROWTH / NUCLEI,RADII,DT,POWER
      COMMON / GROW2 / VINIT,VOLINC,VFRAC,VP
      COMMON / GBGROW / SURINC,SURFAC,SUROCC
      COMMON / DATA1 / TEMP,COMPO
      COMMON / DATA2 / NCELL,LATPAR,SIGMA,DATAST
      COMMON / DATA3 / VMOL,LATICE
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG
      COMMON / DISSO / CABB,CBAA,ENDTIM

      DO 1 I=1,MAXPCP
         PCPFLAG(I)=0
 1    CONTINUE

      WRITE(*,*) 'Duration of the ageing treatment (s) ? '
      READ(*,*) LENGTH
 2    WRITE(*,*) 'Number of steps for the calculation ? '
      READ(*,*) NOSTEP
      IF(NOSTEP.GT.MAXTIM) THEN
         WRITE(*,*) 'ERROR: the maximum number of step is currently ',
     * MAXTIM
         GOTO 2
      ENDIF

      WRITE(*,*) "Number of precipitate: ",NPCP
      
      DT=DEXP(POWER*DLOG(LENGTH))/DBLE(NOSTEP)

      NLINES=1
      LINE(1)='Enter the name you want for the output file'
      CALL DISP_MENU()
      READ(*,*) FILEN
      OPEN(UNIT=2,FILE=FILEN)
      OPEN(UNIT=3,FILE='special')

C      WRITE(*,*) "SHIT ", NV(INIT_PHASE_NO(PRECIP(2)))
C      PAUSE

      DO 10 I=1,NOSTEP
         K=I-1
         TIME=DEXP(DLOG((DBLE(I)*DT))/POWER)
         IF (I.GT.1) THEN
            DTLIN=TIME-DEXP(DLOG((DBLE(K)*DT))/POWER)
         ELSE
            DTLIN=TIME
         ENDIF

         WRITE(*,*) 'Time is: ',TIME,' at iteration: ',I
         GLOBFG=0
         DO 5 PCP=1,NPCP
            NUMERO=INIT_PHASE_NO(PRECIP(PCP))

C Normally, even at the first step, CAVERN should have been properly 
C defined by the set_diffu subroutine.

            IF (PCPFLAG(PCP).NE.1) THEN
             CALL DG(MATRIX,PRECIP(PCP),CAVERN,TEMP,DGT,DGNUC,2)
             IF(DGT.GE.0.0D0) THEN 
                IF(VFRAC(PCP) .NE. 0.0D0) THEN
                   WRITE(*,*) 'Precipitation for ',PRECIP(PCP),
     *                  ' finished after: ',TIME,' s'
                   ENDTIM(PCP)=I
                   CALL RESET_MODIF(PCP)
                   PCPFLAG(PCP)=1
                ELSE
                   WRITE(*,*) "I keep on trying for phase: ",PCP
                ENDIF
             ELSE
              GLOBFG=1
              CALL NUCRATE_HOMO(NV(NUMERO),SIGMA(NUMERO),GTR(NUMERO),
     &             DGNUC,VMOL(1,NUMERO),GT(PCP),RATE(PCP))

C Temporary solution for sigma, sigma must be the second precipitate.       
C Keep triple point nucleation and add removing of used sites
              IF (PCP.EQ.2) THEN
               WRITE(3,*) TIME,DGT
C               NV(NUMERO)=1.0d18
               CALL NUCRATE_TP(NV(NUMERO),SIGMA(NUMERO),SIGMA(1),
     &          GTR(NUMERO),DGNUC,VMOL(1,NUMERO),GT(PCP),RATE(PCP))
               WRITE(*,*) 'Nucleation rate on tp for sigma: ',RATE(PCP)
              ENDIF
C       CALL NUCRATE_DISLO(1.0D11,DGNUC,GTR(NUMERO),SIGMA(NUMERO),
C     & VMOL(1,NUMERO),RATE(PCP))

              NUCLEI(PCP,K)=RATE(PCP)*DTLIN*VINIT
              NUCLEI(PCP,K)=NUCLEI(PCP,K)*(1.0D0-VFRAC(PCP))

              IF (PCP.EQ.2) THEN
               WRITE(*,*) 'Number of new nuclei at :',TIME,' s:',
     &               NUCLEI(PCP,K)
               IF (NUCLEI(PCP,K).GT.NV(NUMERO)) NUCLEI(PCP,K)=NV(NUMERO)
               NV(NUMERO)=NV(NUMERO)-NUCLEI(PCP,K)
C                 IF (NV(NUMERO) .LT. 0.0D0) NV(NUMERO)=0.0d0
               WRITE(*,*) "NV reduced to: ",NV(NUMERO)
              ENDIF

C 08/2000 temporary solution for sigma, put in second position !
C 16/02/01 removed as sigma can be done without tie-line calculation.. but M23C6 needs 
C to be the first precipitate in the list.

              IF(PCP.EQ.1) THEN 
                 X=1
              ELSE 
                 X=2
              ENDIF
              CALL FIND_TIE(PCP,TFLAG,X)
              CALL RADIUS_INCREASE(PCP,I)
              CALL VOLUME_INCREASE(PCP,I)
              CALL MODIF_MATRIX(PCP,I)
             ENDIF
            ELSE
             IF (VFRAC(PCP) .NE. 0.0D0) THEN
              WRITE(*,*) "Here is the matrix in eq with pcp: ", PCP
              WRITE(*,*) (CABB(PCP,KK),KK=1,MAXCPT)
              WRITE(*,*) "Here is actual content"
              WRITE(*,*) (CAVER(KK),KK=1,MAXCPT)
              WRITE(*,*) "Precipitation was finished at iteration: ",
     &          ENDTIM(PCP)
              CALL DISOLV(PCP)
              CALL RADIUS_DECREASE(PCP,I)
C volume_increase should work as is, between 0 and entim              
              CALL VOLUME_INCREASE(PCP,ENDTIM(PCP))
              WRITE (*,*) "Volume fraction: ",VFRAC(PCP)
              CALL MODIF_MATRIX(PCP,ENDTIM(PCP))
C if finished to dissolve in this loop, we need to set modif to zero or it will keep its last value yet again !
              IF (VFRAC(PCP).EQ.0.0D0) THEN
                 CALL RESET_MODIF(PCP)
              ENDIF
C              PAUSE
             ENDIF
            ENDIF

       IF(GLOBFG.EQ.0.AND.PCP.EQ.NPCP) THEN
          GOTO 666
       ENDIF

       WRITE(*,*)

 5     CONTINUE

       CALL MATRIX_CHANGE()

C       IF (MOD(I,10).EQ.0) THEN
       CALL SNAPSHOT(TIME)
C       ENDIF

C       PAUSE

 10   CONTINUE

 666  CLOSE(2)

      END

C **********************************************************************
C
C subroutine snapshot: here all the common variables are declared and 
C it is easy to modify the output to a file. By default, the total volume
C transformed, the nucleation rate and the driving force will be written 
C to a file as a function of time.


      SUBROUTINE SNAPSHOT(TIM)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION TIM
      INTEGER PCP
      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
      INTEGER NPCP

      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT

      DOUBLE PRECISION VOLINC(MAXPCP,MAXTIM),VFRAC(MAXPCP),VP(MAXPCP)
      DOUBLE PRECISION VINIT

      DOUBLE PRECISION MODIF(MAXPCP,MAXCPT)

      DOUBLE PRECISION SUROCC,SURFAC,SURINC(MAXPCP)

      DOUBLE PRECISION TEMP,COMPO(MAXCPT)

      INTEGER NCELL(2,MAXPCP),DATAST(MAXPCP)
      DOUBLE PRECISION LATPAR(MAXPCP,5),SIGMA(MAXPCP)

      DOUBLE PRECISION VMOL(2,MAXPCP),LATICE(MAXPCP)

      INTEGER NCCT(MAXPCP),CCT(MAXPCP,MAXCPT)
      DOUBLE PRECISION DIFFU(MAXCPT)

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG(MAXPCP)

      COMMON / PHASES / MATRIX,PRECIP,NPCP
      COMMON / GROWTH / NUCLEI,RADII,DT
      COMMON / GROW2 / VINIT,VOLINC,VFRAC,VP
      COMMON / GROW3 / MODIF
      COMMON / GBGROW / SURINC,SURFAC,SUROCC
      COMMON / DATA1 / TEMP,COMPO
      COMMON / DATA2 / NCELL,LATPAR,SIGMA,DATAST
      COMMON / DATA3 / VMOL,LATICE
      COMMON / CTROL / NCCT,CCT,DIFFU
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG      

      WRITE(2,100) TIM,RADII(1,1,1),RADII(2,1,1),  
     & (VFRAC(PCP),PCP=1,NPCP)

 100  FORMAT (11(1X,E11.6))
      
      END

C **********************************************************************
C 
C Subroutine DISOLV, experimental
C we should only be there if the precipitation is finished..

      SUBROUTINE DISOLV(PCP)

      INTEGER PCP,FLAG

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*2 INIT_COMPONENT_NAME

      DOUBLE PRECISION VECOMG(MAXCPT)

      INTEGER CCT(MAXPCP,MAXCPT),NCCT(MAXPCP)
      DOUBLE PRECISION DIFFU(MAXCPT)

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG(MAXPCP)

      DOUBLE PRECISION CABB(MAXPCP,MAXCPT),CBAA(MAXPCP,MAXCPT)
      INTEGER ENDTIM(MAXPCP)

C      DOUBLE PRECISION LOCCAB(MAXCPT),LOCCBA(MAXCPT)

      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG
      COMMON / CTROL / NCCT,CCT,DIFFU
      COMMON / DISSO / CABB,CBAA,ENDTIM

C That restores common values

      FLAG=0

      DO 10 I=1,MAXCPT
         CAB(I)=CABB(PCP,I)
         CBA(I)=CBAA(PCP,I)
 10   CONTINUE

      CALL SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG)
      WRITE(*,*) "Content..", CAB(CCT(PCP,2)),CBA(CCT(PCP,2)),
     &  CAVER(CCT(PCP,2))
      WRITE(*,*) "Supersaturation for 1: ", VECOMG(CCT(PCP,1))
      WRITE(*,*) "Supersaturation for 2: ", VECOMG(CCT(PCP,2))

      DO 20 I=1,NCCT(PCP)
         IF (VECOMG(CCT(PCP,I)) .LT. 0.0D0) THEN
            WRITE(*,*) "Supersaturation negative for ",
     &       INIT_COMPONENT_NAME(CCT(PCP,I))
C not really the velocity, the part which does not depend on the radius            
            VG(PCP)=-DIFFU(CCT(PCP,I))*(VECOMG(CCT(PCP,I))**2)/2
            WRITE(*,*) "Dissolution velocity:",VG(PCP)
            FLAG=1
         ENDIF
 20   CONTINUE

C If not negative supersaturation, avoid bug by setting velocity to zero.

      IF (FLAG.EQ.0) THEN
         VG(PCP)=0.0D0
      ENDIF

      END

C **********************************************************************
C 
C Subroutine MODIF_MATRIX, calculates the composition change of the matrix
C for one type of precipitate at a time. 
C
C Because it is summing the volume increments, it assumes that the tie-line
C ie the local equilibrium is the same for all the precipitate. This is not 
C true if capillarity is to play a non-negligible role.
C
C The modification are stored in mole numbers, in a 10,20 table whose first 
C indice refers to the precipitate causing the modification and the second
C one refers to the active component.
C 
C Only when all the modifications have been calculated is the actual matrix
C composition modified.

      SUBROUTINE MODIF_MATRIX(PCP,TIM)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER PCP,TIM

      DOUBLE PRECISION ADDVOL,ADDMOL
      INTEGER INIT_PHASE_NO,ACT_PHASE_NO,ACT_NO_OF_COMPONENTS

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
      DOUBLE PRECISION MODIF(MAXPCP,MAXCPT)
      DOUBLE PRECISION VOLINC(MAXPCP,MAXTIM),VFRAC(MAXPCP),VP(MAXPCP)
      DOUBLE PRECISION VINIT
      DOUBLE PRECISION VMOL(2,MAXPCP),LATICE(MAXPCP)
      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG

      DOUBLE PRECISION CABB(MAXPCP,MAXCPT),CBAA(MAXPCP,MAXCPT)

      COMMON / PHASES / MATRIX,PRECIP
      COMMON / GROW2 / VINIT,VOLINC,VFRAC,VP
      COMMON / GROW3 / MODIF
      COMMON / DATA3 / VMOL,LATICE
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG
      COMMON / DISSO / CABB,CBAA,ENDTIM

      ADDVOL=0.0D0
      ADDMOL=0.0D0

      DO 10 K=0,TIM-1
         ADDVOL=ADDVOL+VOLINC(PCP,K)
 10   CONTINUE      
      WRITE(*,*) "ADDVOL IS: ",ADDVOL
      ADDMOL=ADDVOL/VMOL(1,INIT_PHASE_NO(PRECIP(PCP)))
      
      DO 20 K=1,ACT_NO_OF_COMPONENTS()
         MODIF(PCP,K)=ADDMOL*CBA(K)
         WRITE(*,*) "MODIF(PCP,K) is: ", MODIF(PCP,K)
         CABB(PCP,K)=CAB(K)
         CBAA(PCP,K)=CBA(K)
 20   CONTINUE

      END



C **********************************************************************
C 
C Subroutine RESET_MODIF to avoid keeping on removing the last moles 
C incorporated in the precipitate !!

      SUBROUTINE RESET_MODIF(PCP)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER PCP
      DOUBLE PRECISION MODIF(MAXPCP,MAXCPT)
      COMMON / GROW3 / MODIF

      DO 10 I=1,MAXCPT
         MODIF(PCP,I)=0.0D0
 10      CONTINUE

      END


C **********************************************************************
C 
C Subroutine RADIUS_DECREASE, based on Zener, as low supersaturation expected
C

      SUBROUTINE RADIUS_DECREASE(PCP,TIM)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER PCP,TIM,K

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)

      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT
      DOUBLE PRECISION POWER

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG(MAXPCP)

      DOUBLE PRECISION CABB(MAXPCP,MAXCPT),CBAA(MAXPCP,MAXCPT)
      INTEGER ENDTIM(MAXPCP)

      COMMON / PHASES / MATRIX, PRECIP
      COMMON / GROWTH / NUCLEI,RADII,DT,POWER
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG
      COMMON / DISSO / CABB,CBAA,ENDTIM

      DOUBLE PRECISION TIME,TAU,DELTA,POWER

 10   IF((PRECIP(PCP)(:1)).EQ.' ') THEN
         GOTO 30
      ELSE
         TIME=DEXP(DLOG(DBLE(TIM)*DT)/POWER)
         IF (TIM.GT.1) THEN
            DELTA=TIME-DEXP(DLOG(DBLE(TIM-1)*DT)/POWER)
         ELSE
            DELTA=TIME
         ENDIF

         DO 20 K=0,ENDTIM(PCP)-1
            IF (RADII(PCP,1,K) .GT. 0.0D0) THEN
               RADII(PCP,2,K)=DELTA*VG(PCP)/RADII(PCP,1,K)
               IF (DABS(RADII(PCP,2,K)). GE. RADII(PCP,1,K)) THEN
                  RADII(PCP,2,K)=-RADII(PCP,1,K)
               ENDIF
            ENDIF
C            WRITE(*,*) "Radius 1 for nuc at: ",K," is: ", RADII(PCP,1,K)
C            WRITE(*,*) "Radius2 for nuc at: ",K," is: ", RADII(PCP,2,K)

 20      CONTINUE
      ENDIF

      GOTO 777

 30   WRITE(*,*) 'ERROR IN SUBROUTINE RADIUS_INCREASE: ',
     * 'no precipitate selected.'
         PAUSE 'YOU SHOULD RESTART.'
      

 777  END            

C **********************************************************************
C 
C Subroutine RADIUS_INCREASE, after the calculation of the tie-line, will
C calculate the radius increase for all particles nucleated since the 
C beginning of the process.
C
C I is the precipitate fr which the increase is calculated (PRECIP(J)),
C J is the time step 
C
C RADIUS is the table containing in the first column, the radius of the 
C particle before the step, and in the second column, the radius increase
C during the time step, at time J*DT. 
C 

      SUBROUTINE RADIUS_INCREASE(PCP,TIM)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER PCP,TIM,K

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)

      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT
      DOUBLE PRECISION POWER

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG(MAXPCP)

      COMMON / PHASES / MATRIX, PRECIP
      COMMON / GROWTH / NUCLEI,RADII,DT,POWER
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG

      DOUBLE PRECISION TIME,TAU,DELTA,POWER

 10   IF((PRECIP(PCP)(:1)).EQ.' ') THEN
         GOTO 30
      ELSE
         TIME=DEXP(DLOG(DBLE(TIM)*DT)/POWER)
         IF (TIM.GT.1) THEN
            DELTA=TIME-DEXP(DLOG(DBLE(TIM-1)*DT)/POWER)
         ELSE
            DELTA=TIME
         ENDIF

       DO 20 K=0,TIM-1
          TAU=DEXP(DLOG(DBLE(K)*DT)/POWER)
C radius of pcp nucleated at k deltat
          RADII(PCP,2,K)=0.5D0*VG(PCP)*DELTA/(DSQRT(TIME-TAU))
 20    CONTINUE
      ENDIF

      GOTO 777

 30   WRITE(*,*) 'ERROR IN SUBROUTINE RADIUS_INCREASE: ',
     * 'no precipitate selected.'
         PAUSE 'YOU SHOULD RESTART.'
      

 777  END

C **********************************************************************
C 
C subroutine hard_impig_gb to calculate an equivalent radius increase 
C on the basis of the transformed area..
C
      SUBROUTINE HARD_IMPIG_GB(PCP,TIM)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER K,PCP,TIM

      DOUBLE PRECISION PI,ADDSUR
      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT
      DOUBLE PRECISION SURINC(MAXPCP),SURFAC,SUROCC
      
      COMMON / GROWTH / NUCLEI,RADII,DT
      COMMON / GBGROW / SURINC,SURFAC,SUROCC

      PI=3.14159265

      DO 10 K=0,TIM-1

      WRITE(*,*) RADII(PCP,2,K)
      ADDSUR=((RADII(PCP,1,K)+RADII(PCP,2,K))**2-(RADII(PCP,1,K)**2))

      ADDSUR=ADDSUR*(1-(SUROCC/SURFAC))
      ADDSUR=ADDSUR+(RADII(PCP,1,K)**2)
      ADDSUR=DSQRT(ADDSUR)-RADII(PCP,1,K)

      RADII(PCP,2,K)=ADDSUR
      WRITE(*,*) RADII(PCP,2,K)
C      PAUSE
 10   CONTINUE

      END

C **********************************************************************
C 
C Subroutine VOLUME_INCREASE(I,J), returns the volume increase during
C step time J, for precipitate PRECIP(I)

      SUBROUTINE VOLUME_INCREASE(PCP,TIM)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)
      
      INTEGER PCP,TIM,K
      DOUBLE PRECISION PI,ADDSUR

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
      DOUBLE PRECISION NUCLEI(MAXPCP,MAXTIM),RADII(MAXPCP,2,MAXTIM),DT
      DOUBLE PRECISION VOLINC(MAXPCP,MAXTIM),VFRAC(MAXPCP)
      DOUBLE PRECISION VP(MAXPCP),VINIT
      DOUBLE PRECISION SURINC(MAXPCP),SURFAC,SUROCC

      COMMON / PHASES / MATRIX,PRECIP
      COMMON / GROWTH / NUCLEI,RADII,DT
      COMMON / GROW2 / VINIT,VOLINC,VFRAC,VP
      COMMON / GBGROW / SURINC,SURFAC,SUROCC

      PI=3.14159265

 10   IF((PRECIP(PCP)(:1)).EQ.'') THEN
         GOTO 30
      ELSE
       DO 20 K=0,TIM-1
        VOLINC(PCP,K)=(4.0D0*PI/3.0D0)*
     &  ((RADII(PCP,1,K)+RADII(PCP,2,K))**3-(RADII(PCP,1,K)**3))
        VOLINC(PCP,K)=VOLINC(PCP,K)*NUCLEI(PCP,K)

C Contribution of particles nucleated at KDT:

        ADDSUR=PI*
     &  ((RADII(PCP,1,K)+RADII(PCP,2,K))**2-(RADII(PCP,1,K)**2))*
     &  NUCLEI(PCP,K)
        SURINC(PCP)=SURINC(PCP)+ADDSUR
        
        VP(PCP)=VP(PCP)+VOLINC(PCP,K)
C once the volume change is calculated, update the actual radius
        RADII(PCP,1,K)=RADII(PCP,1,K)+RADII(PCP,2,K)
 20    CONTINUE
      ENDIF

      IF (VP(PCP) .LT. 0.0d0) THEN 
         WRITE(*,*) "Precipitate no ", PCP, " is dissolved."
         VP(PCP)=0.0d0
C         PAUSE
      ENDIF

      VFRAC(PCP)=VP(PCP)/VINIT

      GOTO 777

 30   WRITE(*,*) 'ERROR IN SUBROUTINE VOLUME_INCREASE: ',
     * 'no precipitate selected.'
         PAUSE 'YOU SHOULD RESTART.'
      

 777  END



C **********************************************************************
C
C Subroutine matrix_change to be called when all the contributions to the 
C composition change of the matrix, after one step, have been calculated.
C That is the MODIF(10,20)


      SUBROUTINE MATRIX_CHANGE()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER CPNT,ACT_NO_OF_COMPONENTS

      CHARACTER*20 MATRIX,PRECIP(MAXPCP),FAKE
      DOUBLE PRECISION MODIF(MAXPCP,MAXCPT)
      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG

      COMMON / PHASES / MATRIX,PRECIP
      COMMON / GROW3 / MODIF
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG
      
      DO 10 K=1,MAXPCP
       IF (PRECIP(K)(:1).EQ.' ') GOTO 777
       DO 10 CPNT=1,ACT_NO_OF_COMPONENTS()
        IF(MODIF(K,CPNT).GT.CAVERN(CPNT)/50.0D0) THEN
         WRITE(*,*) 'Subroutine MATRIX_CHANGE: the change of cpnt ',K,
     & ' is not negligible compared to the content of the matrix.'
        ENDIF
        CAVERN(CPNT)=CAVERN(CPNT)-MODIF(K,CPNT)
        IF (CAVERN(CPNT).LT.0.0d0) THEN
         CAVERN(CPNT)=0.0d0
         WRITE(*,*)'Subroutine MATRIX_CHANGE: the number of mole of',
     * ' component ',K,' was negative, set to zero.'
        ENDIF
 10   CONTINUE
       
C here we use mole settings

 777  CALL SETCOM(CAVERN,2)

C reactualise CAVER
      CALL ONLYNORM(MATRIX,FAKE,FAKE)
      CALL COMPUTE_EQUILIBRIUM()
      CALL STORE(CAVER,MATRIX,2)

      END


C **********************************************************************
C 
C SUBROUTINE MOLAR_VOLUME modifies the common table VMOL(2,20). The first 
C column contains the molar volume accountinG for all components. The 
C second, accounting for substitutional elements only.
C It also returns the lattice parameter of the different phases at the 
C actual temperature.
C These table are refered in the INITIAL LIST of phases.

      SUBROUTINE MOLAR_VOLUME()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)
      
      INTEGER INIT_NO_OF_PHASES
      DOUBLE PRECISION AVOGA

      INTEGER NLINES
      CHARACTER*50 LINE(15) 
      
      DOUBLE PRECISION TEMP,COMPO(MAXCPT)
      
      INTEGER NCELL(2,MAXPCP),DATAST(MAXPCP)
      DOUBLE PRECISION LATPAR(MAXPCP,5),SIGMA(MAXPCP)

      DOUBLE PRECISION VMOL(2,MAXPCP),LATICE(MAXPCP)

      COMMON / MENU /NLINES,LINE
      COMMON / DATA1 / TEMP,COMPO
      COMMON / DATA2 / NCELL,LATPAR,SIGMA,DATAST
      COMMON / DATA3 / VMOL,LATICE

      AVOGA=6.0221367D23

      DO 10 I=1,INIT_NO_OF_PHASES()
         CALL LATTICE_PARAMETER(I,LATICE(I))
         IF(DATAST(I).EQ.0) THEN
            VMOL(1,I)=0
            VMOL(2,I)=0
         ELSE
            VMOL(1,I)=(LATICE(I)**3)/(NCELL(1,I)/AVOGA)
            VMOL(2,I)=(LATICE(I)**3)/(NCELL(2,I)/AVOGA)
         ENDIF
 10   CONTINUE

      END


C *******************************************************************
C 
C Subroutine INIT_CALCUL(), perform a first equilibirum calculation 
C with only the matrix, this also sets VINIT, the total volume of the 
C matrix at the beginning.

      SUBROUTINE INIT_CALCUL()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION SUM_OF_COMPONENT_AMOUNT
      INTEGER INIT_PHASE_NO

      INTEGER NLINES
      CHARACTER*50 LINE(15)
      CHARACTER*20 MATRIX,PRECIP,FAKE      
      DOUBLE PRECISION VOLINC(MAXPCP,MAXTIM),VFRAC(MAXPCP)
      DOUBLE PRECISION VP(MAXPCP),VINIT
      DOUBLE PRECISION TEMP,COMPO(MAXCPT)
      DOUBLE PRECISION VMOL(2,MAXPCP),LATICE(MAXPCP)

      COMMON / MENU / NLINES,LINE
      COMMON / PHASES / MATRIX,PRECIP
      COMMON / GROW2 / VINIT,VOLINC,VFRAC,VP
      COMMON / DATA3 / VMOL,LATICE

      CALL ONLYNORM(MATRIX,FAKE,FAKE)
      CALL COMPUTE_EQUILIBRIUM()

      NLINES=3
      LINE(1)='INITIAL EQUILIBRIUM CALCULATION'
      LINE(2)=''
      LINE(3)='only the matrix is present'
      CALL DISP_MENU()
      CALL DISPRES(2)
      VINIT=SUM_OF_COMPONENT_AMOUNT()*VMOL(1,INIT_PHASE_NO(MATRIX))
      WRITE(*,*) 'Total volume: ',VINIT
      END


C *******************************************************************
C Subroutine latpar returns the lattice parameter of a given phase as 
C a function of temperature. The coefficients for the temperature 
C dependence should be passed in the table LATPAR.

      SUBROUTINE LATTICE_PARAMETER(I,A)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER I
      DOUBLE PRECISION A
      INTEGER NCELL(2,MAXPCP)
      DOUBLE PRECISION LATPAR(MAXPCP,5),TEMP
      COMMON / DATA1 / TEMP
      COMMON / DATA2 / NCELL,LATPAR
      
      A=(1.0D0/TEMP)*LATPAR(I,1)+LATPAR(I,2)+TEMP*LATPAR(I,3)+
     & TEMP*TEMP*LATPAR(I,4)+DLOG(TEMP)*LATPAR(I,5)
      A=A*1D-10
      END



C **********************************************************************
C 
C Subroutine FIRST_CHOICE, to select whether a global settings file is 
C used, created, or if manual entry is made.

      SUBROUTINE FIRST_CHOICE()
      
      INTEGER CHOICE,FLAG
      CHARACTER*20 FILNAM

      INTEGER NLINES
      CHARACTER *50 LINE(15)

      COMMON / MENU / NLINES,LINE

      
 1    NLINES=4 
      LINE(1)='CHOOSE BETWEEN:'
      LINE(2)='1) Use a global setting file'
      LINE(3)='2) Create a global setting file'
      LINE(4)='3) Manual entry'
      CALL DISP_MENU()
 10   READ(*,*,err=10) CHOICE

      IF(CHOICE.EQ.1) THEN
         NLINES=3
         LINE(1)='ENTER THE FILE NAME'
         LINE(2)=''
         LINE(3)='Or END to go back to main menu.' 
         CALL DISP_MENU()
 20      READ(*,*,err=20) FILNAM
         IF (FILNAM.EQ.'END') GOTO 1
         CALL READ_GLOBAL_FILE(FILNAM,2)

      ELSE IF (CHOICE.EQ.2) THEN
         NLINES=7
         LINE(1)='CREATING A GLOBAL SETTING FILE'
         LINE(2)='These file store: '
         LINE(3)='.the mpi file you use'
         LINE(4)='.the data file for precipitate'
         LINE(5)='.the composition/temperature file'
         LINE(6)=''
         LINE(7)='Any character to continue'
         CALL DISP_MENU()
         CALL CREATE_GLOBAL_FILE(FLAG)
         IF (FLAG.EQ.1) THEN
            FLAG=0
            GOTO 1
         ENDIF

      ELSE IF (CHOICE.EQ.3) THEN
         CALL MANUAL_SET()
      ENDIF
     
      END

C ********************************************************************** 
C 
C SEQUENCE of subroutines for manual settings
C
      SUBROUTINE MANUAL_SET()
      
      CHARACTER*20 A
       
      CALL START_MT(A,1)
      CALL FIND_DATA(A,1)
      CALL DISP_BILAN()
      CALL SETTINGS()

      END

C **********************************************************************
C
C Subroutine READ_GLOBAL_FILE()

      SUBROUTINE READ_GLOBAL_FILE(GBNAM,Z)
      
      INTEGER INIT_NO_OF_COMPONENTS,Z,I

      INTEGER NLINES
      CHARACTER *50 LINE(15)
      CHARACTER*20 MPINAM,DATNAM,COMTEM,GBNAM

      COMMON / MENU / NLINES,LINE

      IF(Z.EQ.2) GOTO 20

 10   NLINES=1 
      LINE(1)='ENTER THE FILE NAME:'
      CALL DISP_MENU()
 15   READ(*,*,err=15) GBNAM
 20   OPEN(UNIT=1,FILE=GBNAM,ERR=666)
      READ(1,*,ERR=666) MPINAM
      READ(1,*,ERR=666) DATNAM
      READ(1,*,ERR=666) COMTEM    
      CLOSE(1)

      CALL START_MT(MPINAM,2)
      CALL FIND_DATA(DATNAM,2)
      CALL DISP_BILAN()
 55   CALL READ_SET(COMTEM,INIT_NO_OF_COMPONENTS(),I)
      IF(I.EQ.1) GOTO 55

      GOTO 777

 666  NLINES=1
      LINE(1)='BAD GLOBAL FILE'
      CALL DISP_MENU()
      PAUSE
      GOTO 10

 777  END

C **********************************************************************
C 
C Subroutine CREATE_GLOBAL_FILE

      SUBROUTINE CREATE_GLOBAL_FILE(FLAG)

      INTEGER NLINES,FLAG
      CHARACTER *50 LINE(15)
      CHARACTER*20 MPINAM,DATNAM,COMTEM,GBNAM

      COMMON / MENU / NLINES,LINE

      NLINES=6
      LINE(1)='ENTER SUCCESSIVELY:'
      LINE(2)='.the name of the mpi file'
      LINE(3)='.the name of the data file'
      LINE(4)='.the name of the composition/temperature file'
      LINE(5)=''
      LINE(6)='Enter END to go back to main menu'
      CALL DISP_MENU()
 10   READ(*,*,err=100) MPINAM
 20   READ(*,*,err=200) DATNAM
 30   READ(*,*,err=300) COMTEM
      IF(MPINAM.EQ.'END'.OR.DATNAM.EQ.'END'.OR.COMTEM.EQ.'END') THEN
         FLAG=1
         GOTO 777
      ENDIF   
      NLINES=1
      LINE(1)='NAME FOR THE GLOBAL FILE:'
      CALL DISP_MENU()
 40   READ(*,*,err=400) GBNAM

      OPEN(UNIT=1,FILE=GBNAM)
      WRITE(1,*) MPINAM
      WRITE(1,*) DATNAM
      WRITE(1,*) COMTEM
      CLOSE(1)

      GOTO 777

 100  WRITE(*,*) 'WRONG FILE NAME'
      GOTO 10
 200  WRITE(*,*) 'WRONG FILE NAME'
      GOTO 20
 300  WRITE(*,*) 'WRONG FILE NAME'
      GOTO 30
 400  WRITE(*,*) 'WRONG FILE NAME'
      GOTO 40

 777  END


C **********************************************************************
C 
C Subroutine SETTINGS, enter composition and temperature, also 
C can create a file containing these data.


      SUBROUTINE SETTINGS()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)
      
      INTEGER CHOICE,INIT_NO_OF_COMPONENTS,ERFLAG
      CHARACTER*20 FILNAM,FAKE

      INTEGER NLINES,CHOICE(2)
      CHARACTER *50 LINE(15)

      DOUBLE PRECISION TEMP,COMPO(MAXCPT)

      COMMON / MENU / NLINES,LINE
      COMMON / DATA1 / TEMP,COMPO

 10   ERFLAG=0
      NLINES=4
      
      LINE(1)='COMPOSITION AND TEMPERATURE'
      LINE(2)='1) Use a file.'
      LINE(3)='2) Create a file.'
      LINE(4)='3) Set manually.'
      CALL DISP_MENU()
      READ(*,*,ERR=100) CHOICE(1)

      IF (CHOICE(1).EQ.1) THEN
         NLINES=1
         LINE(1)='ENTER THE FILE NAME:'
         CALL DISP_MENU()
         READ(*,*) FILNAM
         CALL READ_SET(FILNAM,INIT_NO_OF_COMPONENTS(),ERFLAG)
         IF(ERFLAG.EQ.1) GOTO 10

      ELSE IF (CHOICE(1).EQ.2) THEN
         NLINES=5
         LINE(1)='CREATING A FILE'
         LINE(2)='You will be asked the temperature, composition'
         LINE(3)='of your alloy and a filename to store these data.'
         LINE(4)=''
         LINE(5)='Any character to go on'
         CALL DISP_MENU()
         READ(*,*) FAKE
         
         NLINES=1
         LINE(1)='ENTER THE AGEING TEMPERATURE'
         CALL DISP_MENU()
         READ(*,*) TEMP
         CALL SET_TEMPERATURE(TEMP)

         NLINES=3
         LINE(1)='ENTER THE COMPOSITION'
         LINE(2)='1) In weight percent'
         LINE(3)='2) In mole percent'
         CALL DISP_MENU()
         READ(*,*) CHOICE(2)
         CALL ENTER_COMPONENT_AMOUNTS(INIT_NO_OF_COMPONENTS(),
     &   CHOICE(2))
         
         NLINES=1
         LINE(1)='ENTER THE FILE NAME'
         CALL DISP_MENU()
         READ(*,*) FILNAM
         CALL WR_SET(FILNAM,INIT_NO_OF_COMPONENTS(),CHOICE(2))
         
      ELSE IF (CHOICE(1).EQ.3) THEN
         NLINES=3
         LINE(1)='ENTER THE COMPOSITION'
         LINE(2)='1) In weight percent'
         LINE(3)='2) In mole percent'
         CALL DISP_MENU()
         READ(*,*) CHOICE(2)
         CALL ENTER_COMPONENT_AMOUNTS(INIT_NO_OF_COMPONENTS(),
     &   CHOICE(2))
         CALL SETCOM(COMPO,CHOICE(2))
         NLINES=1
         LINE(1)='ENTER THE AGEING TEMPERATURE'
         CALL DISP_MENU() 
         READ(*,*) TEMP
         CALL SET_TEMPERATURE(TEMP)
      ENDIF

      GOTO 777

 100  WRITE(*,*) 'Not a valid choice'
      GOTO 10

 777  END

C **********************************************************************
C 
C Subroutine READ_SET(FILENAM,N) read a file containing the temperature 
C and composition, created with WR_SET, N should be the number of 
C components in the file.


      SUBROUTINE READ_SET(FILNAM,N,ERFLAG)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*21 COMENT
      CHARACTER*20 FILNAM,FAKE
      INTEGER I,N,M,ERFLAG

      INTEGER NLINES
      CHARACTER *50 LINE(15)

      DOUBLE PRECISION COMPO(MAXCPT),TEMP
      COMMON / MENU / NLINES,LINE
      COMMON / DATA1 / TEMP,COMPO

      OPEN(UNIT=1,STATUS='OLD',FILE=FILNAM,ERR=5)
      READ(1,*) M
      IF (N.NE.M) THEN
 5       NLINES=1
         LINE(1)='WRONG FILE LENGTH OR BAD FILE NAME'
         CALL DISP_MENU()
         ERFLAG=1
         PAUSE 'Go to enter again the file name'
         GOTO 666
      ENDIF

      READ(1,*) M

      IF(M.EQ.1) THEN
         COMENT='WEIGHT PERCENT TABLE '
      ELSEIF(M.EQ.2) THEN
         COMENT='MOLE FRACTION TABLE '
      ENDIF

      READ(1,*) TEMP

      DO 10 I=1,N
         READ(1,*) COMPO(I)
 10   CONTINUE

      CALL SET_TEMPERATURE(TEMP)
      CALL SETCOM(COMPO,M)
      NLINES=2
      LINE(1)=COMENT//' SUCCESFULLY READ.'
      LINE(2)='Any character to continue'
      CALL DISP_MENU()
      READ(*,*) FAKE

      CALL DISP_COMPONENTS(2)
      
 666  CLOSE(1)
      END



C **********************************************************************
C 
C Subroutine WR_SET(FILENAM,N) write a file containing the temperature 
C and composition entered, together with the number of data for quick 
C identification of non appropriate files

      SUBROUTINE WR_SET(FILNAM,N,WTML)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*20 FILNAM
      INTEGER N,WTML

      INTEGER NLINES
      CHARACTER *50 LINE(15)

      DOUBLE PRECISION COMPO(MAXCPT),TEMP
      COMMON / DATA1 / TEMP,COMPO

      OPEN(UNIT=1,FILE=FILNAM)
      WRITE(1,*) N
      WRITE(1,*) WTML
      WRITE(1,*) TEMP

      DO 10 I=1,N
         WRITE(1,*) COMPO(I)
 10   CONTINUE

      NLINES=1
      LINE(1)=FILNAM//' succesfully created'
      CALL DISP_MENU()

      CLOSE(1)
      
      END


C *******************************************************************
C 
C Subroutine SET_DIFFU, to set the diffusion coefficients

      SUBROUTINE SET_DIFFU()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER FAKE
      INTEGER INIT_NO_OF_COMPONENTS,ACT_COMPONENT_NO
      DOUBLE PRECISION DIFFC,DFE,DCR,DNI
      CHARACTER*2 ACT_COMPONENT_NAME

      INTEGER NLINES
      CHARACTER *50 LINE(15)

      INTEGER NCCT(MAXPCP),CCT(MAXPCP,MAXCPT)
      DOUBLE PRECISION DIFFU(MAXCPT)


      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
      DOUBLE PRECISION TEMP,COMPO(MAXCPT)

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG


      COMMON / MENU / NLINES,LINE
      COMMON / CTROL / NCCT,CCT,DIFFU
      COMMON / PHASES / MATRIX,PRECIP
      COMMON / DATA1 / TEMP,COMPO
      COMMON / TIE / CAVER,CAB,CBA,CAVERN

      DOUBLE PRECISION PARTIAL_SYSTEM_GIBBS_ENERGY

      NLINES=4
      LINE(1)='CALCULATING DIFFUSION COEFFICIENT FOR Fe,Cr,Ni,C'
      LINE(2)='Any character to continue, or E to enter your'
      LINE(3)='own values'
      LINE(4)='Choose E if you are not using a Fe/Cr/Ni steel'
      CALL DISP_MENU()

 10   READ(*,*,ERR=10) FAKE

      IF(FAKE.EQ.'E'.OR. FAKE.EQ.'e') THEN
         FAKE='y'
         GOTO 20
      ENDIF
      FAKE=''
      IF (MATRIX(:1).EQ.' ') CALL SET_MATPRE()      
      CALL ONLYNORM(MATRIX,FAKE,FAKE)

C COMPOSITION MUST HAVE BEEN SET BEFORE !!

      CALL COMPUTE_EQUILIBRIUM()

C store mole fractions.

      CALL STORE(CAVER,MATRIX,2) 
      CALL STORE(CAVERN,MATRIX,4)
      CALL DIFCO_INT(CAVER,TEMP,DIFFC)
      CALL DIFCO_SUB(CAVER(ACT_COMPONENT_NO('Fe')),
     & CAVER(ACT_COMPONENT_NO('Cr')),
     & CAVER(ACT_COMPONENT_NO('Ni')),TEMP,DFE,DCR,DNI)

      WRITE(*,*) 'FAR FIELD ACTIVITY: ',
     & PARTIAL_SYSTEM_GIBBS_ENERGY(ACT_COMPONENT_NO('C'))

C does not affect the values set above, just for test..
      CALL DIFCO_SUB_II(CAVER(ACT_COMPONENT_NO('Fe')),
     & CAVER(ACT_COMPONENT_NO('Cr')),
     & CAVER(ACT_COMPONENT_NO('Ni')),TEMP,DFE,DCR,DNI,DIFFC)

      DIFFU(ACT_COMPONENT_NO('Fe'))=DFE
      DIFFU(ACT_COMPONENT_NO('Cr'))=DCR
      DIFFU(ACT_COMPONENT_NO('Ni'))=DNI
      DIFFU(ACT_COMPONENT_NO('C'))=DIFFC

      WRITE(*,*)'Do you want to set manually some ',
     * 'diffusion coefficients (y/*) ?'
      READ(*,*) FAKE

 20   IF(FAKE.EQ.'y'.OR.FAKE.EQ.'Y') THEN
         NLINES=4
         LINE(1)='ENTER THE NO OF THE COMPONENTS'
         LINE(2)='then the diffusion coefficient'
         LINE(3)=''
         LINE(4)='0 when you have finished.'
 30      CALL DISP_MENU()
         CALL DISP_COMPONENTS(1)
 31      READ(*,*,ERR=30) I
         IF (I.EQ.0) THEN
            GOTO 40
         ELSE
            READ(*,*,ERR=31) DIFFU(I)
         ENDIF
         GOTO 31
      ENDIF
   
 40   NLINES=1
      LINE(1)='DIFFUSION COEFFICIENT'
      CALL DISP_MENU()
      WRITE(*,*) 'Current data: '
      DO 50 I=1,INIT_NO_OF_COMPONENTS()
      WRITE(*,*) ACT_COMPONENT_NAME(I),DIFFU(I)
 50   CONTINUE

      END


C *******************************************************************
C Subroutine START_MT
C

      SUBROUTINE START_MT(MPINAM,Z)

      INTEGER IMODE,IERR,Z
      CHARACTER*20 FILE1,FILE2,MPINAM

      INTEGER NLINES
      CHARACTER *50 LINE(15)
      COMMON / MENU / NLINES,LINE

      CALL INITIALISE_MTDATA(IMODE)
      CALL SGUMEN(1) 
      CALL SGUMEN(2)
      CALL MTOPTN(IMODE,'STAGE_1=NEW')
      FILE1='def'
      FILE2='def'
      IERR=0
      IMODE=0

      IF (Z.EQ.2) THEN
         FILE1=MPINAM
         GOTO 20
      ENDIF

 10   NLINES=6
      LINE(1)='MPI FILE:'
      LINE(2)='To use this program, you should have prepared'
      LINE(3)='a mpi file with MT-DATA, using the ACCESS module.'
      LINE(4)=''
      LINE(5)='WARNING: no more than 20 phases.'
      LINE(6)='What is the name of the file ?'
      CALL DISP_MENU()
      READ(*,*) FILE1

 20   CALL OPEN_MPI_FILE(FILE1, FILE2, IERR)
      CALL SET_PRINT_LEVEL(-2)

      IF(IERR.NE.0) THEN
         WRITE(*,*)'Failure in MPI file reading', IERR
         WRITE(*,*)
         GOTO 666
      ENDIF

      CALL SET_PRESSURE(101325.0D0)

      GOTO 777

 666  PAUSE 'Wrong file name, stop or enter another file name.'
     
      GOTO 10

 777  END


C *******************************************************************
C 
C Subroutine FIND_DATA, look in the data file the information corresponding
C to the names passed as arguments and returns a table with all these info.
C should be called at the beginning.
C The subroutine prepares common tables containing the molar volumes of 
C the different phases found in the mpi file.
C The table STATE will contain 0 or 1 next to the initial number of the 
C phases found in the .mpi file, 1 if there are enough data for the phase, 
C 0 otherwise.

      SUBROUTINE FIND_DATA(FILE1,Z)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*20 FILE1

      INTEGER NCELL(2,MAXPCP),DATAST(MAXPCP),Z
      DOUBLE PRECISION LATPAR(MAXPCP,5),SIGMA(MAXPCP)
      CHARACTER*15 NAME,INIT_PHASE_NAME
      INTEGER I,J,K,INIT_NO_OF_PHASES,INIT_PHASE_NO

      INTEGER NLINES
      CHARACTER *50 LINE(15)

      DOUBLE PRECISION NV(MAXPCP),GTR(MAXPCP)

      INTEGER DATAST(MAXPCP)

      COMMON / MENU / NLINES,LINE
      COMMON / NUCLEA / NV,GTR
      COMMON / DATA2 / NCELL,LATPAR,SIGMA,DATAST

      IF (Z.EQ.2) GOTO 10

 5    NLINES=7
      LINE(1)='Phases informations:'
      LINE(2)='This program requires information about the'
      LINE(3)='phases you will include in the calculation.'
      LINE(4)='They should be found in a file prepared with'
      LINE(5)='the program data.f'
      LINE(6)=''
      LINE(7)='What is the name of this file ?'
      CALL DISP_MENU()
      READ(*,*) FILE1

 10   OPEN(UNIT=1,STATUS='OLD',FILE=FILE1,ERR=666)

C corrected 07-12-2001, wsa limited to number of phases, but there could be more 
C phases in precipitate_data

      DO 20 J=1,20
      READ(1,*,END=30,ERR=666) NAME,NCELL(1,INIT_PHASE_NO(NAME)),
     & NCELL(2,INIT_PHASE_NO(NAME)),
     & LATPAR(INIT_PHASE_NO(NAME),1),LATPAR(INIT_PHASE_NO(NAME),2),
     & LATPAR(INIT_PHASE_NO(NAME),3),LATPAR(INIT_PHASE_NO(NAME),4),
     & LATPAR(INIT_PHASE_NO(NAME),5),SIGMA(INIT_PHASE_NO(NAME)),
     & NV(INIT_PHASE_NO(NAME)),GTR(INIT_PHASE_NO(NAME))
      K=INIT_PHASE_NO(NAME)

      WRITE(*,*) NAME,K

C To characterise the information available.

      IF (NCELL(1,K).NE.0 .AND. LATPAR(K,2).NE.0.0D0) THEN 
         DATAST(K)=1
         IF(SIGMA(K).NE.0.0D0) DATAST(K)=2
      ELSE 
         DATAST(K)=0
      ENDIF

 20   CONTINUE

 30   CLOSE(1)
      GOTO 777

 666  NLINES=3
      LINE(1)='Subroutine FIND_DATA'
      LINE(2)='ERROR: BAD DATA FILE'
      LINE(3)='Please check the file: '//FILE1
      CALL DISP_MENU()
      PAUSE
      GOTO 5

 777  END





C ********************************************************************
C
C Subroutine ENTER_COMPONENTS(INT,CHOICE)
C  modifies the common array COMPO
C used to enter the initial composition, there is no need to declare 
C INIT_NO.. as an integer since its value is passed as an argument.
C 
C Verified !!
C                          ****************

      SUBROUTINE ENTER_COMPONENT_AMOUNTS(K,CHOICE)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER I,K,CHOICE
      DOUBLE PRECISION TEMP,COMPO(MAXCPT) 
      CHARACTER REP
      CHARACTER*2 INIT_COMPONENT_NAME
      COMMON / DATA1 / TEMP,COMPO

      IF(CHOICE.EQ.1) THEN
 5    DO 10 I=1,K
         WRITE(*,*)'Mass of ',INIT_COMPONENT_NAME(I),':'
         READ(*,*) COMPO(I)
 10      CONTINUE
      ELSE 
      DO 20 I=1,K
         WRITE(*,*)'Moles of ',INIT_COMPONENT_NAME(I),':'
         READ(*,*) COMPO(I)
 20      CONTINUE
      ENDIF
      WRITE(*,*)
      WRITE(*,*) 'Sure with your settings ? (*/n)'
      READ (*,*) REP
      IF (REP.EQ.'n' .OR.REP.EQ.'N') GOTO 5
      CALL SETCOM(COMPO,CHOICE)
      END



C *******************************************************************
C
C This subroutine set the mass of components according to the table
C which is passed to it.
C Use ML or WT (1 or 2) to say whether you set moles or mass.
C
C Verified !!
C                          ****************

      SUBROUTINE SETCOM(TABLEC,CHOICE)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER CHOICE,I,INIT_NO_OF_COMPONENTS
      DOUBLE PRECISION TABLEC(MAXCPT)

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         CALL SET_INIT_COMPONENT_MASS(I,TABLEC(I))
10    CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN
      DO 20 I=1,INIT_NO_OF_COMPONENTS()
         CALL SET_INIT_COMPONENT_AMOUNT(I,TABLEC(I))
 20   CONTINUE
      ENDIF
       END





C ******************************************************************
C Subroutine DG returns the Gibbs free energy per kg for the matrix
C of composition TABLEC, and for the precipitate forming from it.
C The method used is valid only if the composition change of the 
C matrix is small enough so that the free energy change can be assimilated
C to a straight line.
C
C CHOICE is an integer which will be directly used when SETCOM is called,
C if CHOICE is 2, then the amount of components is fixed rather than the 
C mass


      SUBROUTINE DG(MATRIX,PRECIP,TABLEC,TEMP,DGT,DGNUC,CHOICE)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*20 MATRIX,PRECIP
      DOUBLE PRECISION TABLEC(MAXCPT),TEMP,DGT,DGNUC
      INTEGER CHOICE
      DOUBLE PRECISION SYSTEM_GIBBS_ENERGY

      CHARACTER*20 PII,PIII
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE,MI,MII,MA
      DOUBLE PRECISION SUM_OF_COMPONENT_AMOUNT
      INTEGER NI,NII,INIT_PHASE_NO,EQUIL_NO_OF_PHASES

      AVOGA=6.0221367D23

C Calculate Gibbs free energy of initial matrix

      NI=INIT_PHASE_NO(MATRIX)
      NII=INIT_PHASE_NO(PRECIP)

      CALL SET_TEMPERATURE(TEMP)
      CALL SETCOM(TABLEC,CHOICE)
      CALL ONLYNORM(MATRIX,PII,PIII)
      CALL COMPUTE_EQUILIBRIUM()

      GA=SYSTEM_GIBBS_ENERGY()

C Calculate Gibbs free energy for matrix+precipitate

      CALL ONLYNORM(MATRIX,PRECIP,PIII)
      CALL COMPUTE_EQUILIBRIUM()

      IF (EQUIL_NO_OF_PHASES().LT.2) THEN
         DGT=0.0D0
         DGNUC=0.0D0
         GOTO 777
      ENDIF

      GB=SYSTEM_GIBBS_ENERGY()

      MI=MOLES_OF_COMPONENTS_IN_PHASE(NII,1)
      MII=SUM_OF_COMPONENT_AMOUNT()

      WRITE(*,*) 'Subroutine DG: precipitate ', PRECIP
      WRITE(*,*) 'Driving force: ',(GB-GA)/MII,' J/mol'
      WRITE(*,*) 'Driving force for nucleation: ',(GB-GA)/MI,' J/mol'

      DGT=(GB-GA)/MII
      DGNUC=(GB-GA)/MI

 777  END



C ******************************************************************
C Subroutine nucrate calculates the nucleation rate with the given 
C parameters for the classical theory.

      SUBROUTINE NUCRATE_HOMO(NV,SIGMA,GTR,DGNUC,VMOL,GT,RATE)

      DOUBLE PRECISION NV,SIGMA,GTR,DGNUC,VMOL,RATE
      DOUBLE PRECISION R,AVOGA,H,PI

      DOUBLE PRECISION GT

      DOUBLE PRECISION TEMP
      COMMON / DATA1 / TEMP

      R=8.31451
      AVOGA=6.0221367D23
      H=6.6260755D-34
      PI=3.1415926536

      WRITE(*,*) "NV is ", NV
      WRITE(*,*) "SIGMA is ",SIGMA
      WRITE(*,*) "VMOL is ",VMOL
      WRITE(*,*) "DGNUC is ",DGNUC

      GT=(16.0D0*PI/3.0D0)*(SIGMA**3)*(VMOL**2)*AVOGA/((DGNUC)**2)

      RATE=NV*(R*TEMP/(AVOGA*H))*(DEXP(-GT/(R*TEMP)))*
     & (DEXP(-GTR/(R*TEMP)))

      END

C ******************************************************************
C Subroutine nucrate_tp for nucleation on a triple point
C corrected 12/12/01 to avoid negative barrier !

      SUBROUTINE NUCRATE_TP(NV,SIGAB,SIGAA,GTR,DGNUC,VMOL,GT,RATE)

      DOUBLE PRECISION NV,SIGAB,SIGAA,GTR,DGNUC,VMOL,GT,RATE
      DOUBLE PRECISION SIGTP
      DOUBLE PRECISION R,AVOGA,H,PI
      DOUBLE PRECISION D,THETA,ETAA,ETAB,ETB
      
      DOUBLE PRECISION TEMP
      COMMON / DATA1 / TEMP

      R=8.31451
      AVOGA=6.0221367D23
      H=6.6260755D-34
      PI=3.1415926536  
C     parameters that should be passed
      THETA=45.0d0

C ignore sigaa and use values to get ~ 10^10 nuclei/s/m3
C 04/04 was 0.423 but Mo content was wrong, re-adjusting
      SIGTP=0.420

      THETA=THETA*(PI/180.0d0)
      ETB=2.0D0*PI*(2.0D0-3.0D0*DCOS(THETA)+(DCOS(THETA))**2)/3
      ETAA=PI*((DSIN(THETA))**2)
      ETAB=4.0D0*PI*(1.0D0-DCOS(THETA))

      GT=(4.0D0/27.0D0)*((ETAB*SIGAB-(3.0/2.0)*ETAA*SIGTP)**3)*
     & (VMOL**2)
      GT=GT/((ETB**2)*(DGNUC**2))
      GT=GT*AVOGA

      IF (GT .LT. 0.0D0) GT=0.0d0

C      WRITE(*,*) "Subroutine nucrate_tp: GT is ", GT
C      WRITE(*,*) DGNUC,TEMP

      RATE=NV*(R*TEMP/(AVOGA*H))*(DEXP(-GT/(R*TEMP)))*
     & (DEXP(-GTR/(R*TEMP)))

C      WRITE(*,*) 'Nucleation on triple point at rate: ',RATE

      END

C ******************************************************************
C Subroutine nucrate_gb(D,SIGAA,SIGAB,THETA,VMOL,GT,RATE)
C D: grain size
C SIGAA: grain boundary surface energy
C SIGAB: surface energy for matrix/precip interface
C GTR: activation energy for the transfert of an atom across the interface
C DGNUC: driving force for nucleation
C THETA: angle of contact precip/grain boundary
C VMOL: molar volume of the precipitate
C GT: barrier for nucleation
C RATE: nucleation rate


      SUBROUTINE NUCRATE_GB(D,SIGAA,SIGAB,GTR,DGNUC,THETA,
     & VMOL,GT,RATE)
      
      DOUBLE PRECISION D,SIGAA,SIGAB,THETA,VMOL,TEMP,GT,RATE
      DOUBLE PRECISION DGNUC,GTR

      DOUBLE PRECISION ETAA,ETAB,ETB
      DOUBLE PRECISION NV

      DOUBLE PRECISION R,AVOGA,H,PI

      COMMON / DATA1 / TEMP

      R=8.31451
      AVOGA=6.0221367D23
      H=6.6260755D-34
      PI=3.1415926536

      IF(DGNUC.EQ.0.0D0) THEN 
         RATE=0.0d0
         GOTO 777
      ENDIF

      ETB=2.0D0*PI*(2.0D0-3.0D0*DCOS(THETA)+(DCOS(THETA))**2)/3
      ETAA=PI*((DSIN(THETA))**2)
      ETAB=4.0D0*PI*(1.0D0-DCOS(THETA))

      GT=(4.0D0/27.0D0)*((ETAB*SIGAB-ETAA*SIGAA)**3)*(VMOL**2)
      GT=GT/((ETB**2)*(DGNUC**2))
      GT=GT*AVOGA

      IF(GT.LT.0.0D0) THEN 
         GT=0.0D0 
         WRITE(*,*) 'Subroutine NUCRATE_GB: barrierless nucleation'
      ENDIF


C Estimation of the surface area from the diameter, assume a nucleus 
C is about 

      NV=(8.0D0/(3.00*D))
      NV=NV/(PI*((50.0D-9)**2))
      RATE=NV*(R*TEMP/(AVOGA*H))*(DEXP(-GT/(R*TEMP)))*
     & (DEXP(-GTR/(R*TEMP)))

C This is the rate per second and unit volume

      
 777  END


C ******************************************************************
C Subroutine nucrate_dislo(DGNUC,VBETA,GTR,SIGMA,TEMP,RATE)
C 

      SUBROUTINE NUCRATE_DISLO(LD,DGNUC,GTR,SIGMA,VMOL,RATE)
      
      DOUBLE PRECISION LD,DGNUC,GTR,SIGMA,TEMP,RATE,VMOL
      
      DOUBLE PRECISION G,NU,BURGER
      DOUBLE PRECISION R,AVOGA,H,PI

      DOUBLE PRECISION B,ALPHA,RADCR(2),D,E,F
      DOUBLE PRECISION GT1,GT2,GSTAR
      DOUBLE PRECISION NV,VOLCEL

      COMMON / DATA1 / TEMP

      R=8.31451
      AVOGA=6.0221367D23
      H=6.6260755D-34
      PI=3.1415926536

C ** CHANGE ACCORDING TO MATERIAL: FOR AUSTENITE (DIETER)

      G=65.6D9
      NU=0.28D0

C with the lattice parameter of an 18/12
      BURGER=(3.5889+5.433D-5*TEMP+1.467D-8*(TEMP**2))/DSQRT(2.0D0)
      BURGER=BURGER*1.0D-10

      B=G*BURGER*BURGER/(4.0D0*PI*(1.0D0-NU))

      ALPHA=(SIGMA**2)+(2.0D0*B/PI)*(DGNUC/VMOL)

      IF(ALPHA.LE.0.0D0) THEN 
         WRITE(*,*) 'ERROR IN SUBROUTINE NUCRATE_DISLO:',
     * ' no energy barrier'
      ENDIF

      RADCR(1)=(-SIGMA+DSQRT(ALPHA))/(2.0D0*(DGNUC/VMOL))
      RADCR(2)=(-SIGMA-DSQRT(ALPHA))/(2.0D0*(DGNUC/VMOL))

C Calculates the extrema of G(r)

      D=PI*RADCR(1)*RADCR(1)*DGNUC/VMOL
      E=B*DLOG(RADCR(1)/BURGER)
      F=2.0D0*PI*RADCR(1)*SIGMA

      GT1=D-E+F

      D=PI*RADCR(2)*RADCR(2)*DGNUC/VMOL
      E=B*DLOG(RADCR(2)/BURGER)
      F=2.0D0*PI*RADCR(2)*SIGMA

      GT2=D-E+F

      GSTAR=GT2-GT1

C Calculates the nucleation rate

      VOLCEL=(1.0D-10*(3.5889+5.433D-5*TEMP+1.467D-8*(TEMP**2)))**3
      NV=4.0D0/VOLCEL
      NV=DEXP((1.0D0/3.0D0)*DLOG(NV))
      RATE=NV*LD*R*TEMP/(H*AVOGA)*DEXP((-GTR-GSTAR)/(R*TEMP))

      END



C ********************************************************************
C
C Subroutine Set_component_control, modifies the COMMON variable CCT(20)
C this array will contain the active number of the controlling component.
C
C Verified !!
C 
C                          ****************

      SUBROUTINE SET_COMPONENT_CONTROL()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER I,PCP
      CHARACTER*2 ACT_COMPONENT_NAME
      INTEGER INIT_NO_OF_COMPONENTS

      INTEGER NLINES
      CHARACTER *50 LINE(15)
      
      INTEGER NCCT(MAXPCP),CCT(MAXPCP,MAXCPT)
      DOUBLE PRECISION DIFFU(MAXCPT)

      INTEGER NPCP
      CHARACTER*20 MATRIX,PRECIP(MAXPCP)

      COMMON / PHASES / MATRIX,PRECIP(MAXPCP),NPCP
      COMMON / MENU / NLINES,LINE
      COMMON / CTROL / NCCT,CCT,DIFFU

      DO 30 PCP=1,NPCP

      NLINES=8
      LINE(1)='CHOOSING THE CONTROLLING COMPONENTS'
      LINE(2)=''
      LINE(3)='How many controlling components for: '
      LINE(5)=''
      LINE(4)=PRECIP(PCP)
      LINE(6)='Note that calculation time increase exponentially ' 
      LINE(7)='with the number of controlling components. '
      LINE(8)='Enter 1 to use the bulk mass balance tie-line'
      CALL DISP_MENU()
      READ(*,*) NCCT(PCP)
      NLINES=3
      LINE(1)='CHOOSING THE CONTROLLING COMPONENTS'
      LINE(2)=''
      LINE(3)='Enter the active number in the list below:'
      CALL DISP_MENU()
      CALL DISP_COMPONENTS(4)

      DO 10 I=1,NCCT(PCP)
 5     READ(*,*) CCT(PCP,I)
      IF(CCT(PCP,I).GT.INIT_NO_OF_COMPONENTS().OR.CCT(PCP,I).LE.0) THEN
       WRITE(*,*) 'Error...'
       GOTO 5
      ENDIF
      IF(DIFFU(CCT(PCP,I)).EQ.0.0d0) THEN
       WRITE(*,*) 'There is no diffusion data for this component'
       WRITE(*,*) 
       WRITE(*,*) 'Please enter a diffusion coefficient for ',
     & ACT_COMPONENT_NAME(CCT(PCP,I))
       READ(*,*) DIFFU(CCT(PCP,I))
       WRITE(*,*) 
       IF(I.LT.NCCT(PCP)) WRITE(*,*) 'Next component ', 
     *'(enter active number)'
       ENDIF

 10   CONTINUE
      DO 20 I=NCCT(PCP)+1,MAXCPT
         CCT(PCP,I)=0
 20   CONTINUE

 30   CONTINUE

      END

C *******************************************************************
C 
C This subroutine sets Matrix and precipitate
C 
C

      SUBROUTINE SET_MATPRE()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)
      
      INTEGER INIT_NO_OF_PHASES,I,K
      
      CHARACTER*20 INIT_PHASE_NAME

      CHARACTER*50 LINE(15)
      INTEGER NLINES,NPCP

      CHARACTER*20 MATRIX,PRECIP(MAXPCP)

      COMMON / MENU / NLINES,LINE
      COMMON / PHASES / MATRIX,PRECIP,NPCP

      NLINES=7
      LINE(1)='CHOOSE THE MATRIX AND THE PRECIPITATES'
      LINE(2)=''
      LINE(3)='Although you can enter up to ten precipitates,'
      LINE(4)='only one is accounted for now, set it first.'
      LINE(5)=''
      LINE(6)='Enter the initial number of the phases for the'
      LINE(7)='matrix then the precipitates, 0 when finished.'
      CALL DISP_MENU()

      CALL DISP_PHASES()

      K=0

 10   READ(*,*,ERR=10) I
      MATRIX=INIT_PHASE_NAME(I)
      WRITE(*,*) MATRIX(:10),' is now the matrix.'
      K=K+1
 20   READ(*,*,ERR=20) I
      IF(I.EQ.0.AND.K.LT.2) THEN 
         WRITE(*,*) 'No second phase chosen, choose one !.'
         GOTO 20
      ELSEIF(I.EQ.0.AND.K.GE.2) THEN
         GOTO 30
      ELSE
         PRECIP(K)=INIT_PHASE_NAME(I)
         WRITE(*,*) 'Precipitate ',K,' is now ',PRECIP(K)
      ENDIF
      K=K+1
      GOTO 20
 30   WRITE(*,*) 'Number of precipitates: ',K-1
      NPCP=K-1
      
      END

C *******************************************************************
C
C This subroutine classifies normal the phase whose names are 
C passed as arguments and absent all the others.
C
C Verified !!
C                          ****************

      SUBROUTINE ONLYNORM(PI,PII,PIII)

      CHARACTER*20 PI,PII,PIII
      CHARACTER*20 PVAR
      CHARACTER*20 INIT_PHASE_NAME
      INTEGER INIT_NO_OF_PHASES

      DO 10 I=1,INIT_NO_OF_PHASES()
         PVAR=INIT_PHASE_NAME(I)

         IF (PVAR.EQ.PI .OR. PVAR.EQ.PII .OR. PVAR.EQ.PIII) THEN 
            CALL SET_INIT_PHASE_CLASS(I,1)
         ELSE
            CALL SET_INIT_PHASE_CLASS(I,0) 
         ENDIF
 10    CONTINUE
      END



C *******************************************************************
C
C Subroutine FIND_TIE(MATRIX,PRECIP,CCT1,CCT2,K), will find the tie-line 
C which satisfies the flux-balance for elements corresponding to the 
C active numbers passed through CCT1 and CCT2. K should be use later on 
C to activate choices between different geometry.
C 
C CAVER must content the concentration in various component far from the
C boundary. (x bar)
C 
C PCP is the precipitate considered (his number PRECIP(PCP))      
C
C 16/03/2000 ADDITION of a simplified version for pure substances. Call
C with K=2
C                          ****************

      SUBROUTINE FIND_TIE(PCP,DIFLAG,K)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

C Common variables
C / DATA1
      DOUBLE PRECISION TEMP,COMPO(MAXCPT)      
C / PHASES
      CHARACTER*20 MATRIX,PRECIP(MAXPCP)
C / CTROL
      INTEGER CCT(MAXPCP,MAXCPT),NCCT(MAXPCP)
      DOUBLE PRECISION DIFFU(MAXCPT)
C / TIE
      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT),CBA(MAXCPT)
      DOUBLE PRECISION CAVERN(MAXCPT),VG(MAXPCP)

C ARGUMENTS
      INTEGER PCP,DIFLAG,K

C local db

      DOUBLE PRECISION SAVEN(MAXCPT)
      DOUBLE PRECISION V(MAXCPT),S(MAXCPT)
      DOUBLE PRECISION VECOMG(MAXCPT)
      DOUBLE PRECISION STEP(MAXCPT)
      DOUBLE PRECISION A,B,EPSIL
C local ch and integer

      CHARACTER*10 GEOMETRY
      CHARACTER*20 PRECP
      CHARACTER*20 ACT_COMPONENT_NAME,FAKE
      INTEGER INI(MAXCPT)
      INTEGER INIT_COMPONENT_NO
      INTEGER EQUIL_NO_OF_PHASES,ACT_PHASE_NO
      INTEGER ACT_NO_OF_COMPONENTS,LOOP
      INTEGER I,FLAG
      INTEGER WT,ML,ITMAX

C TEMPORARY
      INTEGER ACT_COMPONENT_NO,C
      DOUBLE PRECISION PARTIAL_SYSTEM_GIBBS_ENERGY,REFERENCE,REFSIGN

C flag to know what component we are looking at: 1 for the pseudo-ternary, 
C 2 for the third comtrollong component, 3 for the fourth,etc
      INTEGER CFLAG,CNT

      COMMON / PHASES / MATRIX,PRECIP
      COMMON / CTROL / NCCT,CCT,DIFFU
      COMMON / DATA1 / TEMP,COMPO
      COMMON / TIE / CAVER,CAB,CBA,CAVERN,VG

      GEOMETRY='SPHERICAL'
      
      PRECP=PRECIP(PCP)

      WT=1
      ML=2
      ITMAX=50
      EPSIL=1.0D-5
      I=0
      FLAG=0
C temporary ?
      C=ACT_COMPONENT_NO('C')

      IF(CCT(PCP,2).NE.0) THEN
         IF(DIFFU(CCT(PCP,1)).EQ.0.0D0 .OR. DIFFU(CCT(PCP,2)).EQ.0.0D0) 
     & THEN
            WRITE(*,*)'There is no data for the diffusion of one 
     &           of the controlling elements'
            DIFLAG=1
            GOTO 666
         ENDIF
      ENDIF

C to get far-field here !
      CALL ONLYNORM(MATRIX,FAKE,FAKE)
      CALL COMPUTE_EQUILIBRIUM

      WRITE(*,*) 'Activity of carbon in far-field:', 
     & PARTIAL_SYSTEM_GIBBS_ENERGY(C)
      REFERENCE=PARTIAL_SYSTEM_GIBBS_ENERGY(C)

      CALL ONLYNORM(MATRIX,PRECP,FAKE)
      CALL COMPUTE_EQUILIBRIUM()
      CALL STORE(CAB,MATRIX,ML)
      CALL STORE(CBA,PRECP,ML)
      CALL SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG)
      CALL FINDS_PRIME(VECOMG,CCT,S,PCP,GEOMETRY)

C this is to check that the sign of the difference does not change, 
C otherwise we miss the point were |diff| < epsilon and just go to
C former velocities equality

      REFSIGN=REFERENCE-PARTIAL_SYSTEM_GIBBS_ENERGY(C)
      WRITE(*,*) 'REFSIGN IS: ', REFSIGN

      WRITE(*,*) 'For the mass-balance tie-line:'
      CALL DISPRES(2)

      CALL PRODVEC(S,DIFFU,V,2)
      CALL DISP_VEC('Velocities from: ',CCT,PCP,V,NCCT(PCP),3)

C If there is only one controlling component, finish here:

      If (CCT(PCP,2).EQ.0) THEN
         VG(PCP)=V(CCT(PCP,1))
         GOTO 666
      ENDIF

C Find the numbers of the controlling in the initial components
C list, then store in AMINI1 and AMINI2 the values corresponding to
C the mass-balance equilibrium (most often not the initial one).

      DO 10 LOOP=1,ACT_NO_OF_COMPONENTS()
         INI(LOOP)=INIT_COMPONENT_NO(ACT_COMPONENT_NAME(LOOP))
 10   CONTINUE

      DO 20 LOOP=1,ACT_NO_OF_COMPONENTS()
         SAVEN(LOOP)=CAVERN(LOOP)
 20   CONTINUE


C Swap to suit algorithm

      IF (V(CCT(PCP,2)).LT.V(CCT(PCP,1))) THEN 
         LOOP=CCT(PCP,1)
         CCT(PCP,1)=CCT(PCP,2)
         CCT(PCP,2)=LOOP
      ENDIF

      IF(K.EQ.2) GOTO 100

      CNT=0
      CFLAG=0

C If we have not already done one iteration in this pseudo-ternary,
C initiate the steps and if we are coming from another controlling comp 
C modif, restore the initial values (exept from the varying comp).
C CFLAG.EQ.0 is to avoid not defining STEP(CCT(1)) at the very begining.
C

 25   IF (CFLAG.NE.1) THEN 
          DO 30 LOOP=1,ACT_NO_OF_COMPONENTS()
             IF (CFLAG.EQ.0.OR.LOOP.NE.CCT(PCP,CFLAG+1)) THEN
                CAVERN(LOOP)=SAVEN(LOOP)
                STEP(LOOP)=CAVERN(LOOP)/10.0D0
             ENDIF
 30       CONTINUE
      ENDIF

C If we have done a modification to change the pseudo-ternary, are we still 
C in the two-phase field ?

 40   IF(CFLAG.GT.1) THEN
       CALL COMPUTE_EQUILIBRIUM()
       CALL STORE(CAB,MATRIX,ML)
       CALL STORE(CBA,PRECP,ML)
       CALL SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG)
C If we are not, reduce the step (could be >0 or <0), CAVERN as not yet been 
C changed so we set a new amount for the controlling component CFLAG+1, 
C and keep the change if we are in the two phase field.

       IF(EQUIL_NO_OF_PHASES().LT.2 .OR. 
     & VECOMG(CCT(PCP,CFLAG+1)).GT.1.0D0) THEN
         STEP(CCT(PCP,CFLAG+1))=STEP(CCT(PCP,CFLAG+1))/2.0D0
          CALL SET_INIT_COMPONENT_AMOUNT(INI(CCT(PCP,CFLAG+1)),
     & CAVERN(CCT(PCP,CFLAG+1))+STEP(CCT(PCP,CFLAG+1)))
          GOTO 40
       ENDIF
       CAVERN(CCT(PCP,CFLAG+1))=CAVERN(CCT(PCP,CFLAG+1))+
     & STEP(CCT(PCP,CFLAG+1))
      ENDIF

C Now solve in the pseudo-ternary.

 50   CALL SET_INIT_COMPONENT_AMOUNT(INI(CCT(PCP,1)),CAVERN(CCT(PCP,1))
     & -STEP(CCT(PCP,1)))

       I=I+1
       CALL COMPUTE_EQUILIBRIUM()

C If we fall out of two-phase domain, reduce the step, and restart 
C with the same initial value. Same thing if we don't leave the two
C phase domain but choose a tie-line which gives a negative value 
C for the other component.

       CALL STORE(CAB,MATRIX,ML)
       CALL STORE(CBA,PRECP,ML)
       CALL SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG)

       IF (EQUIL_NO_OF_PHASES().LT.2 .OR. VECOMG(CCT(PCP,1)).GT.1.0D0 
     & .OR. VECOMG(CCT(PCP,2)).LT.0.0D0) THEN 
        STEP(CCT(PCP,1))=STEP(CCT(PCP,1))/5.0D0
        GOTO 50
       ENDIF

       CALL FINDS_PRIME(VECOMG,CCT,S,PCP,GEOMETRY)
       CALL PRODVEC(S,DIFFU,V,2)

C If we missed the equality point, go back with a reduced step

       IF (V(CCT(PCP,1)).GT.V(CCT(PCP,2))) THEN 
          STEP(CCT(PCP,1))=STEP(CCT(PCP,1))/2.0D0
          GOTO 50
       ENDIF

C same as above, but with activity
C       WRITE(*,*) 'AND NOW REFSIGN IS:', 
C     &  (REFERENCE-PARTIAL_SYSTEM_GIBBS_ENERGY(C))

       IF ((REFSIGN * (REFERENCE -
     &      PARTIAL_SYSTEM_GIBBS_ENERGY(C))).LT.0) 
     &      THEN
C         WRITE(*,*) 'MISSED ME !'
          STEP(CCT(PCP,1))=STEP(CCT(PCP,1))/2.0D0
          GOTO 50
       ENDIF
C

       CAVERN(CCT(PCP,1))=CAVERN(CCT(PCP,1))-STEP(CCT(PCP,1))
       
C       CALL DISPRES(2)
C       WRITE(*,*) 'Activity NOW:', 
C     &      PARTIAL_SYSTEM_GIBBS_ENERGY(ACT_COMPONENT_NO('C'))

C When the velocities are almost equal
C
C       IF(DABS(1.0D0-(V(CCT(PCP,1))/V(CCT(PCP,2)))).LT.(5.0d-2)) THEN
C          IF (CFLAG.EQ.0) CFLAG=2
C          GOTO 70
C       ENDIF

C Replace by equality of activity:
         

       IF ((REFERENCE-PARTIAL_SYSTEM_GIBBS_ENERGY(C)).LT.
     &      (DABS(REFERENCE)/50000.0d0)) THEN
          IF (CFLAG.EQ.0) CFLAG=2
          GOTO 70
       ENDIF

C Avoid hanging if things don't work. Flag will tell why we exit.

       IF(I.GT.ITMAX) THEN
          FLAG=1
          GOTO 80
       ENDIF  

      GOTO 50

      IF(CFLAG.EQ.0) CFLAG=2


C ** from here check for the third component and compare..


C Check there is a third controlling component
 70   IF(CCT(PCP,CFLAG+1).NE.0) THEN
C Is this component absorbed or rejected by the precipitate
       IF ((CBA(CCT(PCP,CFLAG+1))-CAB(CCT(PCP,CFLAG+1))).LT.0.0D0) THEN
C Is omega positive for this element ?
        IF (VECOMG(CCT(PCP,CFLAG+1)).GT.0.0D0) THEN
C Are we close to the solution ?
         IF (DABS(S(CCT(PCP,CFLAG+1))/S(CCT(PCP,1))-1.0D0).GT.0.1D0) 
     & THEN

C If we are not, is omega too small or too large
          IF(S(CCT(PCP,CFLAG+1)).LT.S(CCT(PCP,1))) THEN 
           STEP(CCT(PCP,CFLAG+1))=CAVERN(CCT(PCP,CFLAG+1))/2.0D0
          ELSE
           STEP(CCT(PCP,CFLAG+1))=-CAVERN(CCT(PCP,CFLAG+1))/2.0D0
          ENDIF
C Else for close to solution
         ELSE 
            CFLAG=CFLAG+1
            CNT=0
            GOTO 70
         ENDIF
C Else for omega positive
        ELSE
           STEP(CCT(PCP,CFLAG+1))=CAVERN(CCT(PCP,CFLAG+1))/2.0D0
        ENDIF
C Else for rejected: case of an absorbed component:
       ELSE
        IF(VECOMG(CCT(PCP,CFLAG+1)).GT.0.0D0) THEN
        IF (DABS(S(CCT(PCP,CFLAG+1))/S(CCT(PCP,1))-1.0D0).GT.0.1D0) THEN
          IF(S(CCT(PCP,CFLAG+1)).GT.S(CCT(PCP,1))) THEN
           STEP(CCT(PCP,CFLAG+1))=CAVERN(CCT(PCP,CFLAG+1))/2.0D0
          ELSE 
           STEP(CCT(PCP,CFLAG+1))=-CAVERN(CCT(PCP,CFLAG+1))/2.0D0
          ENDIF
         ELSE 
          CFLAG=CFLAG+1
          CNT=0
          GOTO 70
         ENDIF
        ELSE 
         STEP(CCT(PCP,CFLAG+1))=-CAVERN(CCT(PCP,CFLAG+1))/2.0D0
        ENDIF
       ENDIF


      CNT=1
      CALL SET_INIT_COMPONENT_AMOUNT(INI(CCT(PCP,CFLAG+1)),
     & CAVERN(CCT(PCP,CFLAG+1))+STEP(CCT(PCP,CFLAG+1))) 
      
      GOTO 25
      ENDIF

 80   IF(FLAG.EQ.1) THEN
         WRITE(*,*)
         WRITE(*,*) 'Subroutine FIND_TIE: could not find a solution in', 
     * ' less than ',ITMAX,' iterations.'
      ELSE
         WRITE(*,*)
         WRITE(*,*) 'Tie-line found: '
         CALL DISPRES(ML)
C TEMPORARY 
      WRITE(*,*) 'Activity of carbon for flux balance:', 
     & PARTIAL_SYSTEM_GIBBS_ENERGY(ACT_COMPONENT_NO('C'))
      ENDIF

      CALL DISP_VEC('Velocities from:',CCT,PCP,V,NCCT(PCP),3)

C Restore the common table CAVERN 

      DO 90 LOOP=1,ACT_NO_OF_COMPONENTS()
         CAVERN(LOOP)=SAVEN(LOOP)
 90   CONTINUE   

C store the velocity in vg AND stop here for 'complex' tie-line

C changed since we don't really reach same velocities ([] speaking, but if we 
C could include cross effect, it should be similar..
C      VG(PCP)=(V(CCT(PCP,1))+V(CCT(PCP,2)))/2.0d0
      VG(PCP)=V(CCT(PCP,1))
      GOTO 666

C Start here simple tie-line for pure substances *******


 100  A=CAVERN(CCT(PCP,1))
      B=0.0d0
 110  CALL SET_INIT_COMPONENT_AMOUNT(INI(CCT(PCP,1)),(A+B)/2.0D0)
C compensate with Fe to avoid change in xc (otherwise get negative 
C supersaturation.      
      CALL SET_INIT_COMPONENT_AMOUNT(1,CAVERN(1)+
     & (CAVERN(CCT(PCP,1))-(A+B)/2.0d0))
      CALL COMPUTE_EQUILIBRIUM()
      IF((A-B).LT.EPSIL.AND.EQUIL_NO_OF_PHASES().EQ.2) THEN
         GOTO 555
      ELSE
       IF (EQUIL_NO_OF_PHASES().LT.2) THEN
         B=(A+B)/2.0D0
        ELSE
         A=(A+B)/2.0D0
       ENDIF

      GOTO 110
      ENDIF
      
 555  CALL STORE(CAB,MATRIX,ML)
      CALL STORE(CBA,PRECP,ML)
      CALL SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG)
      CALL FINDS_PRIME(VECOMG,CCT,S,PCP,GEOMETRY)
      WRITE(*,*) 'Local equilibrium for the flux-balance:'
      CALL DISPRES(2)
      CALL PRODVEC(S,DIFFU,V,2)
      WRITE(*,*) 'Velocities fixed by slowest element: ',
     * V(CCT(PCP,1))

C TEMPORARY 
      WRITE(*,*) 'Activity of carbon in far-field:', 
     & PARTIAL_SYSTEM_GIBBS_ENERGY(ACT_COMPONENT_NO('C'))

      VG(PCP)=V(CCT(PCP,1))
      
 666  END
      


C *************************************************************
C 
C Subroutine prodvec perform a particular kind of vector product, 
C as it returns a vector C, so that Ci=Ai*Bi

      SUBROUTINE PRODVEC(A,B,C,CHOICE)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION A(MAXCPT),B(MAXCPT),C(MAXCPT)
      INTEGER ACT_NO_OF_COMPONENTS,I,CHOICE

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,ACT_NO_OF_COMPONENTS()
         C(I)=A(I)*C(I)
 10      CONTINUE
      ELSE IF(CHOICE.EQ.2) THEN
      DO 20 I=1,ACT_NO_OF_COMPONENTS()
         C(I)=A(I)*DSQRT(B(I))
 20      CONTINUE
      ENDIF
      
      END







C *************************************************************
C
C Subroutine PREP_TABLE, to create a 464 lines table containing
C the value of S(Omega) by step of 0.002, up to 0.928
C
C The second column contains the slope: v(2,I) is the slope between
C v(1,I) and v(1,I+1)
C
C                       **************

      SUBROUTINE PREP_TABLE(TABLE,FILENAME)
      
      CHARACTER*20 FILENAME
      DOUBLE PRECISION TABLE(2,500)
      DOUBLE PRECISION A,B,STEP
      INTEGER I
      OPEN(UNIT=1,FILE=FILENAME)
      
      STEP=0.002D0

      READ(1,*,END=100) A,B
      TABLE(1,1)=B

      DO 10 I=2,500
         READ(1,*,END=100) A,B
         TABLE(1,I)=B
         TABLE(2,I-1)=(B-TABLE(1,I-1))/STEP
 10   CONTINUE

 100  CLOSE(1)

      END



C *********************************************************************
C
C Subroutine SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG) returns the supersaturation
C in a vector VECOMG(20) by active element number.
C

      SUBROUTINE SUPERSAT_ALL(CAB,CBA,CAVER,VECOMG)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION CAB(MAXCPT),CBA(MAXCPT),CAVER(MAXCPT)
      DOUBLE PRECISION VECOMG(MAXCPT)
      DOUBLE PRECISION FOMEG
      INTEGER I
      
      DO 10 I=1,MAXCPT
         VECOMG(I)=FOMEG(CAB(I),CBA(I),CAVER(I))
C         IF (VECOMG(I).LT.0.0d0) WRITE(*,*) "Negative superst",I
 10   CONTINUE

      END



C ********************************************************
C To calculate OMEGA
C
      DOUBLE PRECISION FUNCTION FOMEG(CAB,CBA,CAVER)
      DOUBLE PRECISION CAB,CBA,CAVER
      FOMEG=(CAVER-CAB)/(CBA-CAB)
      END


C ********************************************************************
C 
C Subroutine STORE(TABLEC,NAME,I)
C 
C to store the composition of the phases in equilibrium
C Use predefined constants WT(1) and ML(2) to get weight fraction 
C or mole fraction.
C
C if the integer passed is 3, store the mass of components (not fraction)
C if it is 4, the amount.
C Verified !!
C                          ****************

      SUBROUTINE STORE(TABLEC,NAME,I)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION TABLEC(MAXCPT)
      DOUBLE PRECISION COMPONENT_X_OF_PHASE
      DOUBLE PRECISION COMPONENT_W_OF_PHASE
      DOUBLE PRECISION COMPONENT_MOLES_IN_PHASE
      DOUBLE PRECISION COMPONENT_MASS_IN_PHASE
      CHARACTER*20 NAME
      INTEGER EQUIL_PHASE_NO,PHASE_PRESENT_AT_EQUILIBRIUM
      INTEGER ACT_NO_OF_COMPONENTS
      INTEGER I,J,N,M

C Need to check the phase is present at euqilibrium
      
      N=EQUIL_PHASE_NO(NAME)
      IF (N.EQ.0) THEN
      GOTO 50
      ENDIF

C If the phase is present at equilibrIum, we have its number and 
C find from it the active number.

      M=PHASE_PRESENT_AT_EQUILIBRIUM(N)
 
C If I is 1 (WT) then store weight fraction table 

      IF (I.EQ.1) THEN
      DO 10 J=1,ACT_NO_OF_COMPONENTS()
         TABLEC(J)=COMPONENT_W_OF_PHASE(J,M,2)
 10      CONTINUE
      ENDIF

      IF(I.EQ.2) THEN
      DO 20 J=1,ACT_NO_OF_COMPONENTS()
         TABLEC(J)=COMPONENT_X_OF_PHASE(J,M,2)
 20      CONTINUE
      ENDIF
      
      IF (I.EQ.3) THEN
      DO 30 J=1,ACT_NO_OF_COMPONENTS()
         TABLEC(J)=COMPONENT_MASS_IN_PHASE(J,M,2)
 30      CONTINUE
      ENDIF

      IF(I.EQ.4) THEN
      DO 40 J=1,ACT_NO_OF_COMPONENTS()
         TABLEC(J)=COMPONENT_MOLES_IN_PHASE(J,M,2)
 40      CONTINUE
      ENDIF

 50   END

      


C *********************************************************************
C Subroutine FINDS_PRIME called with geometry 'spherical' or 'planar'
C uses two precalculated values table normally loaded with PREP_TABLE.
C Asymptotic expansions are used according to determined optimum.
C Spherical: change for asymptotic exp at omega >= 0.990
C Planar: change for asymptotic exp at omega >= 0.994
C                               *********

      SUBROUTINE FINDS_PRIME(VECOMG,CCT,S,PCP,GEOMETRY)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*10 GEOMETRY
      DOUBLE PRECISION VECOMG(MAXCPT),S(MAXCPT)
      DOUBLE PRECISION PI
      INTEGER CCT(MAXPCP,MAXCPT)
      INTEGER I,J,PCP

      DOUBLE PRECISION PLAGRO(2,500),SPHGRO(2,500)
      COMMON / PRECAL / SPHGRO,PLAGRO

C Dummy variables for rough.

      DOUBLE PRECISION FI,FII,FIII

      PI=3.141593

      DO 5 J=1,MAXCPT
         S(J)=0.0D0
 5    CONTINUE

      I=1


      IF (CCT(PCP,I).EQ.0) THEN
         WRITE(*,*) 'Subroutine FINDS_PRIME: no active components', 
     * ' selected'
      ENDIF

      IF (GEOMETRY.EQ.'SPHERICAL') THEN
 10      IF (VECOMG(CCT(PCP,I)).LT.0.0D0) THEN 
            S(CCT(PCP,I))=0.0D0
         ELSE IF (DINT(VECOMG(CCT(PCP,I))/0.002D0).EQ.0) THEN
            S(CCT(PCP,I))=DSQRT(2.0*VECOMG(CCT(PCP,I)))
C            CALL ROUGH(VECOMG(CCT(PCP,I)),S(CCT(PCP,I)),30,FI,FII,FIII)
         ELSE IF (VECOMG(CCT(PCP,I)).LT.0.990D0) THEN
       S(CCT(PCP,I))=SPHGRO(1,IDINT(DINT(VECOMG(CCT(PCP,I))/0.002D0)))+
     & DMOD(VECOMG(CCT(PCP,I)),0.002D0)*
     & SPHGRO(2,IDINT(DINT(VECOMG(CCT(PCP,I))/0.002D0)))
         ELSE IF (VECOMG(CCT(PCP,I)).GE.0.990D0) THEN
            S(CCT(PCP,I))=DSQRT(6.0D0/(1.0D0-VECOMG(CCT(PCP,I))))
         ENDIF
C         WRITE(*,*) 'Called with ',GEOMETRY,' S is: ',S(CCT(PCP,I))
         I=I+1
         IF (CCT(PCP,I).NE.0) GOTO 10

      ELSE IF (GEOMETRY.EQ.'PLANAR') THEN
 20      IF (VECOMG(CCT(PCP,I)).LT.0.0D0) THEN 
            S(CCT(PCP,I))=0.0D0
         ELSE IF (DINT(VECOMG(CCT(PCP,I))/0.002D0).EQ.0) THEN
            S(CCT(PCP,I))=2.0/DSQRT(PI)*VECOMG(CCT(PCP,I))
         ELSE IF (VECOMG(CCT(PCP,I)).LT.0.994D0) THEN
       S(CCT(PCP,I))=PLAGRO(1,IDINT(DINT(VECOMG(CCT(PCP,I))/0.002D0)))+
     & DMOD(VECOMG(CCT(PCP,I)),0.002D0)*
     & PLAGRO(2,IDINT(DINT(VECOMG(CCT(PCP,I))/0.002D0)))            
         ELSE IF (VECOMG(CCT(PCP,I)).GE.0.994D0) THEN
            S(CCT(PCP,I))=DSQRT(2.0D0/(1.0D0-VECOMG(CCT(PCP,I))))
         ENDIF
         I=I+1
         IF (CCT(PCP,I).NE.0) GOTO 10

      ELSE 
         WRITE(*,*) "Unvalid geometry"
      ENDIF   
      END



C ********************************************************
C  Subroutine Rough approaches the solution for S in Zener's 
C model. Omega has to be given, S is returned, Iter is the number 
C of iterations, to be given. INF, MID and SUP return the value 
C of the equation defining S to allow control of the solution.
C
C Verified, not always work (S>0.83)!
C Used only for < 0.002 (file)
C                          ****************


      SUBROUTINE ROUGH(OMEGA,S,ITER,INF,SUP,MID)
      DOUBLE PRECISION OMEGA,S,INF,SUP,MID
      DOUBLE PRECISION SINF,SSUP,FINF,FSUP,FMID
      DOUBLE PRECISION PINF,PPINF,PSUP,PPSUP
      DOUBLE PRECISION F
      INTEGER ITER,I
      
      I=0
      SINF=SQRT(2.0D0*OMEGA)
      SSUP=SQRT(6.0D0*OMEGA)
      
 10   I=I+1
      CALL PSI(SINF,PINF,PPINF)
      FINF=F(SINF,PINF,OMEGA)

 20   CALL PSI(SSUP,PSUP,PPSUP)
      FSUP=F(SSUP,PSUP,OMEGA)
      IF (FSUP.LT.0.0D0) THEN
         SSUP=2.0D0*SSUP
         GOTO 20
      ENDIF

      S=(SINF+SSUP)/2.0D0

C The variables PINF and PPINF are used again to avoid too many 
C different var.

      CALL PSI(S,PMID,PPMID)
      FMID=F(S,PMID,OMEGA)

      IF (FINF*FMID.GT.0.0D0) THEN
         SINF=S
      ELSEIF (FSUP*FMID.GT.0.0D0) THEN
         SSUP=S
      ELSEIF (FINF*FSUP.GT.0.0D0) THEN
         WRITE(*,*)'Problem, the limits have the same sign'
      ENDIF

      IF(I.LT.ITER) GOTO 10

      INF=FINF
      SUP=FSUP
      MID=FMID
      END



C *******************************************************
C
C This subroutine returns PSI(S) and its derivative , 
C it uses a numerical integration for 
C erf(S/2) 
C
C Verified !!
C                          ****************

      SUBROUTINE PSI(A,C,D)
      DOUBLE PRECISION U,STEPU,SUM
      DOUBLE PRECISION A,C,D
      DOUBLE PRECISION PI
      PI=3.14159265359D0
      SUM=0.0D0
C The step in the numerical calculation of erf

      STEPU=A/5000.0D0

      U=STEPU/2.0
      D=-(1.0D0/A**2)*DEXP(-(A**2)/4.0D0)

 10   SUM=SUM+(EXP(-U**2))*STEPU
      U=U+STEPU
      IF (U.LT.(A/2.0)) THEN 
         GOTO 10
      ENDIF
      C=(1.0D0/A)*DEXP(-(A**2)/4.0D0)-(SQRT(PI)/2.0D0)+SUM

      END


C ********************************************************
C this is the function whose root is looked for.
C

      DOUBLE PRECISION FUNCTION F(S,PSI,OMEGA)
      DOUBLE PRECISION S,PSI,OMEGA
      F=(S*S*S)-2.0D0*OMEGA*DEXP(-(S**2)/4.0D0)*(1.0D0/PSI)
      END




C ********************************************************
C Subroutine DIFCO_SUB, calculates the diffusion 
C coefficients for Fe,Cr,Ni as found in J.Agren, ISIJ,V32 1992
C
C The amount of Fe is assumed to be the complement of Cr and Ni,
C unless a non-zero value is passed to the subroutine. 
C The XFE etc are mole fraction.
C
C Verified !!
C
C                          ****************

      SUBROUTINE DIFCO_SUB(XFE,XCR,XNI,TEMP,DFE,DCR,DNI)
      DOUBLE PRECISION XFE,XCR,XNI,TEMP
      DOUBLE PRECISION DFE,DCR,DNI
      DOUBLE PRECISION Q,OMEGA

      Q=35880.0D0*XFE+34410.0D0*XNI+36130.0D0*XCR
      OMEGA=3.202D-4*XFE+3.164D-4*XNI+2.364D-4*XCR
      DFE=OMEGA*DEXP(-Q/TEMP)

      Q=35650.0D0*XFE+34600.0D0*XNI+38010.0D0*XCR
      OMEGA=1.111D-4*XFE+3.808D-4*XNI+1.542D-4*XCR
      DNI=OMEGA*DEXP(-Q/TEMP)

      Q=36100.0D0*XFE+32080.0D0*XNI+34620.0D0*XCR
      OMEGA=2.747D-4*XFE+1.117D-4*XNI+1.444D-4*XCR
      DCR=OMEGA*DEXP(-Q/TEMP)

      END

      

C *********************************************************
C Subroutine DIFCO_INT, calculates the diffusivity of carbon as 
C found in Z.Metallkd. 1994v7,p502, Bjorn Jonsson.
C 
C Only Fe, Cr, and Ni are considered, influences of Mo, Mn and others
C are neglected.
C There is the need to know the proportion of sites free on the 
C second sublattice, ie the amount of any other intersticial.
C
C TABLEC must contain the mole number of active components in FCC_A1,
C so that active component 1 amount is stored in TABLEC(1), etc.
C Phi is the thermodynamical factor, with MT-DATA, it was calculated 
C that for a 20/25, Phi could be approximated to 
C    1.04516+7.46601e-29*Cc (where Cc is the molar conc of C per m3)
C 
C    1.00918+7.49759e-29*Cc for 18/12
C
C Verified !!
C
C                          ****************

      SUBROUTINE DIFCO_INT(TABLEC,TEMP,DIFF)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION TABLEC(MAXCPT),TEMP,PHI,DIFF,MOBIL
      INTEGER NFE,NCR,NNI,NMO,NMN,NC,NN
      DOUBLE PRECISION YFE,YCR,YNI,TMO,YMN,YCC,YNN
      DOUBLE PRECISION SITES,VOL
      DOUBLE PRECISION R
      INTEGER ACT_COMPONENT_NO


      R=8.31451

C Get the active number of all elements on first sublattice, then calculate
C the number of sites on this first sublattice. The number of sites on the 
C second is identical.

      SITES=0
      DELTAG=0
      NFE=ACT_COMPONENT_NO('Fe')
      NCR=ACT_COMPONENT_NO('Cr')
      NNI=ACT_COMPONENT_NO('Ni')
      NMO=ACT_COMPONENT_NO('Mo')
      NMN=ACT_COMPONENT_NO('Mn')
      NC=ACT_COMPONENT_NO('C')
      NN=ACT_COMPONENT_NO('N')


      SITES=TABLEC(NFE)+TABLEC(NCR)+TABLEC(NNI)+TABLEC(NMO)
     & +TABLEC(NMN)
      YFE=TABLEC(NFE)/SITES
      YCR=TABLEC(NCR)/SITES
      YNI=TABLEC(NNI)/SITES
      YMO=TABLEC(NMO)/SITES
      YMN=TABLEC(NMN)/SITES
      YCC=TABLEC(NC)/SITES
      YVA=(SITES-TABLEC(NC)-TABLEC(NN))/SITES

      DELTAG=(YCR*YCC*(-2.0D-6))+YCR*YVA*(-150000.0-90.0*TEMP)
      DELTAG=DELTAG+YFE*YCC*(72007.0-137.463*TEMP)
      DELTAG=DELTAG+YFE*YVA*(-147723.0-88.646*TEMP)
      DELTAG=DELTAG+YNI*YCC*(-154700.0+31.0*TEMP)
      DELTAG=DELTAG+YNI*YVA*(-154700.0-81.7*TEMP)
      DELTAG=DELTAG+YCR*YFE*(YCC+YVA)*(1+YCR-YFE)*(-240000.0+170.0*TEMP)
      DELTAG=DELTAG+YCR*YNI*(YCC+YVA)*(1+YCR-YNI)*(-74000.0)
      DELTAG=DELTAG+YFE*YNI*(YCC+YVA)*5000.0
      DELTAG=DELTAG+YFE*YNI*(YFE-YNI)*(YCC+YVA)*15000.0

      MOBIL=DEXP(DELTAG/(R*TEMP))

C Default is 20/25 for unit cell volume (2)

      CALL CELPAR(TEMP,2,VOL)
      PHI=1.04516+7.46601D-29*(4.0*YCC/VOL)
C      DIFF=MOBIL*YVA*PHI
C wnat to pass mobility back 
      DIFF=MOBIL
      END



C *******************************************************************
C 
C Subroutine CELPAR, returns the volume of a unit dell of austenite 
C as a function of austenite and of an integer which should indicate 
C whether to use the formula for a 18/12 or the one for a 20/25.
C
C See DATA4.
C
C                          ****************

      SUBROUTINE CELPAR(TEMP,K,A)
      DOUBLE PRECISION TEMP,A
      INTEGER K
      IF (K.EQ.1) THEN 
         A=3.5889+5.433D-5*TEMP+1.467D-8*(TEMP**2)
      ELSEIF (K.EQ.2) THEN 
         A=3.5839+5.351D-5*TEMP+1.397D-8*(TEMP**2)
      ELSE
         WRITE(*,*)'Error in subroutine CELPAR: incorrect argument'
      ENDIF
      A=A**3
      END

         



C **********************************************************************
C 
C Subroutine DEFINE_ZERO(), calculates the matrix composition at 
C equilibrium for a given temperature and choosen phases. For example,
C this will allow to consider the growth of M23C6 in the matrix 
C composition obtained by solution treatment at 1100C.

      SUBROUTINE DEFINE_ZERO()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER INIT_NO_OF_PHASES,I,NI,INIT_PHASE_NO,K
      INTEGER INIT_NO_OF_COMPONENTS,NI
      CHARACTER*20 INIT_PHASE_NAME
      CHARACTER*2 INIT_COMPONENT_NAME
      DOUBLE PRECISION COMPONENT_W_OF_PHASE
      DOUBLE PRECISION TSTART

      INTEGER NLINES
      CHARACTER*50 LINE(15)
      
      CHARACTER*20 MATRIX,PRECIP(MAXPCP)

      DOUBLE PRECISION TEMP,COMPO(MAXCPT)

      COMMON / MENU / NLINES,LINE
      COMMON / PHASES / MATRIX,PRECIP
      COMMON / DATA1 / TEMP,COMPO

      K=0

      NLINES=9
      LINE(1)='SETTING A STARTING POINT:'
      LINE(2)='You can perform an equilibrium calculation with'
      LINE(3)='more than 2 phases and use the matrix composition'
      LINE(4)=''
      LINE(5)='Enter the phases number you expect to be present:'
      LINE(6)='0 when you have entered all phases.'
      LINE(7)=''
      LINE(8)='Enter 0 directly if the actual setting'
      LINE(9)='is the starting point.'
      
      CALL DISP_MENU()

      DO 1 I=1,INIT_NO_OF_PHASES()
         CALL SET_INIT_PHASE_CLASS(I,0)
 1    CONTINUE
      
      CALL DISP_PHASES()
 5    READ(*,*,ERR=5) I
      IF (I.EQ.0.AND.K.NE.0) THEN
         CALL DISP_PHASES()
         GOTO 20
      ELSEIF(I.EQ.0.AND.K.EQ.0) THEN
         GOTO 777
      ELSEIF(I.GT.INIT_NO_OF_PHASES()) THEN
         WRITE(*,*)'No phases matching this number'
      ELSE
         CALL SET_INIT_PHASE_CLASS(I,1)
         WRITE(*,*)'Phase ',INIT_PHASE_NAME(I)
         K=K+1
      ENDIF
      GOTO 5

 20   NLINES=1
      LINE(1)='ENTER THE TEMPERATURE DEFINING THE STARTING POINT'
      CALL DISP_MENU()
 22   READ(*,*,ERR=22) TSTART
      CALL SET_TEMPERATURE(TSTART)
      NLINES=1
      LINE(1)='Computing equilibrium'
      CALL DISP_MENU()
      CALL COMPUTE_EQUILIBRIUM
      CALL DISPRES(2)

      IF (MATRIX(:1).EQ.' ') THEN
      WRITE(*,*) 'You need to have set the matrix to go further.'
      WRITE(*,*) 'Enter its name: '
 24   READ(*,*,ERR=24) MATRIX
      ENDIF

      NI=INIT_PHASE_NO(MATRIX)

      DO 30 I=1,INIT_NO_OF_COMPONENTS()
         COMPO(I)=COMPONENT_W_OF_PHASE(I,NI,1)
         COMPO(I)=COMPO(I)*100.0D0
 30   CONTINUE

      WRITE(*,*) 'New composition at the beginning of the ageing ',
     * 'treatment:'

      DO 40 I=1,INIT_NO_OF_COMPONENTS()
         WRITE(*,*) INIT_COMPONENT_NAME(I),': ',COMPO(I)
 40   CONTINUE

      CALL SET_TEMPERATURE(TEMP)
      CALL SETCOM(COMPO,1)

 777  END



C ***********************************************************************
C 
C Subroutine JACOMU, calculates the hessian matrix for G(n1,..nn) and 
C returns it in JACO. For debugging purposes, the matrix is written to 
C 'jacobi'
C By multiplying by VINIT, we get dmu/dc rather than dmu/dn
C
C Because CAVERN, passed in MATCO, is reffered using the active list, 
C so is JACO.

      SUBROUTINE JACOMU(MATCO,TAMP,JACO)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION SUM_OF_COMPONENT_AMOUNT,N
      DOUBLE PRECISION MATCO(MAXCPT),TAMP,JACO(MAXCPT,MAXCPT)
      DOUBLE PRECISION DIVI
      DOUBLE PRECISION DELTA(2,MAXCPT),STEP(MAXCPT)

      DOUBLE PRECISION SUM_OF_COMPONENT_AMOUNT,N
      DOUBLE PRECISION PARTIAL_SYSTEM_GIBBS_ENERGY 
      INTEGER ACT_NO_OF_COMPONENTS,NCOM
      DOUBLE PRECISION SUM_OF_COMPONENT_AMOUNT

      DOUBLE PRECISION VINIT

      CHARACTER*20 MATRIX,FAKE
      COMMON / PHASES / MATRIX
      COMMON / GROW2 / VINIT

      WRITE(*,*) "SUBROUTINE JACOMU: CALCULATING [d2G/dxidxj](i,j)"

      NCOM=ACT_NO_OF_COMPONENTS()
      CALL ONLYNORM(MATRIX,FAKE,FAKE)

C set the composition in moles.

      CALL SETCOM(MATCO,2)
      CALL SET_TEMPERATURE(TAMP)
      CALL COMPUTE_EQUILIBRIUM()
      N=SUM_OF_COMPONENT_AMOUNT()  
      WRITE(*,*) 'Total number of moles: ',N
      CALL DISPRES(2)

      OPEN(UNIT=2,FILE='jacobi')

      DIVI=500.0D0      
      DO 10 I=1,NCOM
         STEP(I)=MATCO(I)/DIVI
         WRITE(*,*) 'No: ',MATCO(I),' gives: ',STEP(I)
 10   CONTINUE

      DO 30 I=1,NCOM
       CALL SET_INIT_COMPONENT_AMOUNT(I,MATCO(I)-STEP(I))
       CALL COMPUTE_EQUILIBRIUM()
       CALL DISPRES(2)
       DO 22 J=1,NCOM
       DELTA(1,J)=PARTIAL_SYSTEM_GIBBS_ENERGY(J)
       WRITE(*,*) DELTA(1,J)
 22    CONTINUE       

       CALL SET_INIT_COMPONENT_AMOUNT(I,MATCO(I))
       WRITE(*,*)

       CALL SET_INIT_COMPONENT_AMOUNT(I,MATCO(I)+STEP(I))
       CALL COMPUTE_EQUILIBRIUM()
       CALL DISPRES(2)
       DO 24 J=1,NCOM
        DELTA(2,J)=PARTIAL_SYSTEM_GIBBS_ENERGY(J)
        WRITE(*,*) DELTA(2,J)
 24    CONTINUE
       
       CALL SET_INIT_COMPONENT_AMOUNT(I,MATCO(I))
       DO 26 J=1,NCOM
        JACO(J,I)=(DELTA(2,J)-DELTA(1,J))/(2.0D0*STEP(I))

C HERE, multiplied by V to get dmui/dxj under the approximation that even 
C localy, ntotal is constant. I am an idiot.. that should be N

        N=SUM_OF_COMPONENT_AMOUNT()

        WRITE(*,*) 'For ',J,' ',I,': ',JACO(J,I)
        JACO(J,I)=JACO(J,I)*N
 26   CONTINUE

      WRITE(2,100) (JACO(J,I),J=1,NCOM)
 30   CONTINUE
      CLOSE(2)

 100  FORMAT(10(E12.5,1X))

      END





C ********************************************************************
C
C Subroutine DISPRES(K)
C 
C used to display the results of an equilibrium calculation, the 
C integer is used to choose the kind of table to display
C Use predefined constants WT and ML to get weight fraction table
C or mole fraction table.
C
C Verified !!
C                          ****************

      SUBROUTINE DISPRES(K)
      
      INTEGER K,I,J,L,M,N
      INTEGER EQUIL_NO_OF_PHASES,ACT_NO_OF_COMPONENTS
      INTEGER PHASE_PRESENT_AT_EQUILIBRIUM

      DOUBLE PRECISION COMPONENT_W_OF_PHASE,MASS_IN_PHASE
      DOUBLE PRECISION COMPONENT_X_OF_PHASE
      DOUBLE PRECISION MOLES_OF_COMPONENTS_IN_PHASE
      
      CHARACTER*10 ACT_PHASE_NAME
      CHARACTER*2 ACT_COMPONENT_NAME

      L=ACT_NO_OF_COMPONENTS()
      WRITE(*,*) EQUIL_NO_OF_PHASES()
      WRITE(*,*)

      IF (K.EQ.1) THEN
         WRITE(*,*)'Weight and components weight fractions'
         WRITE(*,300)
         DO 10 I=1,EQUIL_NO_OF_PHASES()
            N=PHASE_PRESENT_AT_EQUILIBRIUM(I)

         IF (L.GT.5) THEN
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,5)
          WRITE(*,200) MASS_IN_PHASE(N,2),
     &    (COMPONENT_W_OF_PHASE(J,N,2), J=1,5)
          WRITE(*,*)
         ELSE 
        WRITE(*,100) ACT_PHASE_NAME(N),
     &  (ACT_COMPONENT_NAME(J), J=1,ACT_NO_OF_COMPONENTS())
        WRITE(*,200) MASS_IN_PHASE(N,2),
     &  (COMPONENT_W_OF_PHASE(J,N,2), J=1,ACT_NO_OF_COMPONENTS())
         GOTO 21
         ENDIF

         IF (L.GT.10) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=6,10)
            WRITE(*,500) (COMPONENT_W_OF_PHASE(J,N,2), J=6,10)
            WRITE(*,*)
         ELSE
            M=6
            GOTO 20
         ENDIF

         IF (L.GT.15) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=11,15)
            WRITE(*,500) (COMPONENT_W_OF_PHASE(J,N,2), J=11,15)
            WRITE(*,*)
         ELSE
            M=11
            GOTO 20
         ENDIF

 20    WRITE(*,400) 
     & (ACT_COMPONENT_NAME(J), J=M,ACT_NO_OF_COMPONENTS())
       WRITE(*,500) 
     &  (COMPONENT_W_OF_PHASE(J,N,2), J=M,ACT_NO_OF_COMPONENTS())

 21    WRITE(*,300)
       WRITE(*,*)
 10      CONTINUE
      ENDIF

      IF (K.EQ.2) THEN
         WRITE(*,*)'Moles and components mole fractions'
         WRITE(*,300)
         DO 30 I=1,EQUIL_NO_OF_PHASES()
            N=PHASE_PRESENT_AT_EQUILIBRIUM(I)

         IF (L.GT.5) THEN
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,5)
          WRITE(*,200) MOLES_OF_COMPONENTS_IN_PHASE(N,2),
     &    (COMPONENT_X_OF_PHASE(J,N,2), J=1,5)
          WRITE(*,*)
         ELSE 
          WRITE(*,100) ACT_PHASE_NAME(N),
     &    (ACT_COMPONENT_NAME(J), J=1,ACT_NO_OF_COMPONENTS())
          WRITE(*,200) MOLES_OF_COMPONENTS_IN_PHASE(N,2),
     &   (COMPONENT_X_OF_PHASE(J,N,2), J=1,ACT_NO_OF_COMPONENTS())
          GOTO 41
         ENDIF

         IF (L.GT.10) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=6,10)
            WRITE(*,500) (COMPONENT_X_OF_PHASE(J,N,2), J=6,10)
            WRITE(*,*)
         ELSE
            M=6
            GOTO 40
         ENDIF

         IF (L.GT.15) THEN 
            WRITE(*,400) (ACT_COMPONENT_NAME(J),J=11,15)
            WRITE(*,500) (COMPONENT_X_OF_PHASE(J,N,2), J=11,15)
            WRITE(*,*)
         ELSE
            M=11
            GOTO 40
         ENDIF

 40      WRITE(*,400) 
     &   (ACT_COMPONENT_NAME(J), J=M,ACT_NO_OF_COMPONENTS())
         WRITE(*,500) 
     &   (COMPONENT_X_OF_PHASE(J,N,2), J=M,ACT_NO_OF_COMPONENTS())
 
 41      WRITE(*,300)
         WRITE(*,*)
 
 30      CONTINUE
      ENDIF

 100     FORMAT (1X,A,1X,5(5X,A,4X))
 200     FORMAT (E11.6,1X,5(1X,F9.7,1X))
 300     FORMAT (66('-'))
 400     FORMAT (12X,5(5X,A,4X))
 500     FORMAT (12X,5(1X,F9.7,1X))

      END




C *********************************************************************
C
C Subroutine DISP_VEC(title,vector,size,choice) display the content of
C the vector passed as an argument, with the title. Choice allow to choose
C the reference system (init or active)
C
C                               *********

      SUBROUTINE DISP_VEC(TITLE,CCT,PCP,VECTOR,SIZE,CHOICE)

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      DOUBLE PRECISION VECTOR(MAXCPT)
      INTEGER SIZE,CHOICE,CCT(MAXPCP,MAXCPT)
      CHARACTER*20 TITLE

      CHARACTER*2 INIT_COMPONENT_NAME,ACT_COMPONENT_NAME
      INTEGER J,PCP

      WRITE(*,*)
      WRITE(*,*) TITLE

      IF (CHOICE.EQ.1) THEN
         DO 10 J=1,SIZE
         WRITE(*,100) INIT_COMPONENT_NAME(J),':',VECTOR(J)
 10   CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN
         DO 20 J=1,SIZE
         WRITE(*,100) ACT_COMPONENT_NAME(J),':',VECTOR(J)
 20   CONTINUE
      ENDIF

      IF (CHOICE.EQ.3) THEN
         DO 30 J=1,SIZE
         WRITE(*,*) ACT_COMPONENT_NAME(CCT(PCP,J)),VECTOR(CCT(PCP,J))
 30   CONTINUE
      ENDIF

 100  FORMAT (A,1X,A,1X,F9.7)

      END




C *******************************************************************
C
C According to the value of K, this subroutine displays the list
C of different components, their amount in weight or moles.
C Do not call with K=4 before a succesfull equilibrium calculation.
C
C Verified !!
C                          ****************

      SUBROUTINE DISP_COMPONENTS(CHOICE)

      INTEGER CHOICE

      DOUBLE PRECISION INIT_COMPONENT_MASS
      DOUBLE PRECISION INIT_COMPONENT_MOLES
      INTEGER ACT_NO_OF_COMPONENTS
      CHARACTER*2 INIT_COMPONENT_NAME,ACT_COMPONENT_NAME

      WRITE(*,*)

      IF (CHOICE.EQ.1) THEN
      DO 10 I=1,INIT_NO_OF_COMPONENTS()
         WRITE(*,100) 'Component',I,'is',INIT_COMPONENT_NAME(I)
 10   CONTINUE
      ENDIF

      IF (CHOICE.EQ.2) THEN 
      DO 20 I=1,INIT_NO_OF_COMPONENTS()
       WRITE(*,150) INIT_COMPONENT_NAME(I),' mass: ',
     & INIT_COMPONENT_MASS(I)
 20   CONTINUE
      ENDIF

      IF(CHOICE.EQ.3) THEN
         DO 30 I=1,INIT_NO_OF_COMPONENTS()
            WRITE(*,200) 'Component',I,'amount is',
     &      INIT_COMPONENT_MOLES(I)
 30      CONTINUE
      ENDIF

      IF (CHOICE.EQ.4) THEN 
         DO 40 I=1,ACT_NO_OF_COMPONENTS()
            WRITE(*,100) 'Active Component', I, 'is',
     &       ACT_COMPONENT_NAME(I)
 40         CONTINUE
      ENDIF

 100  FORMAT (10X,A,1X,I2,1X,A,1X,A)
 150  FORMAT (10X,A,1X,A,1X,F7.4)
 200  FORMAT (10X,A,1X,I2,1X,A,1X,F7.4)
      END




C *******************************************************************
C
C  This subroutine lists the phases initially present, together 
C  with their status.
C
C Verified !!
C                          ****************

      SUBROUTINE DISP_PHASES()
      CHARACTER*20 INIT_PHASE_NAME
      CHARACTER*6 ANSW
      WRITE(*,*)
      DO 10 I=1,INIT_NO_OF_PHASES()
         IF (NORMAL_INIT_PHASE(I)) THEN 
            ANSW='normal'
            ELSE
            ANSW='absent'
         ENDIF
         WRITE(*,100) 'The phase',INIT_PHASE_NAME(I),'is', ANSW
 10   CONTINUE
 100  FORMAT (A,1X,A,1X,A,1X,A)
      END



C **********************************************************************
C 
C Subroutine DISP_BILAN() displays the phases found in the mpi file and 
C the informations available.

      SUBROUTINE DISP_BILAN()

      PARAMETER (MAXPCP=10,MAXTIM=20000,MAXCPT=15)
      
      CHARACTER FAKE
      CHARACTER*10 INIT_PHASE_NAME
      CHARACTER*40 PINFO

      INTEGER I,INIT_NO_OF_PHASES
      
      INTEGER NCELL(2,MAXPCP),DATAST(MAXPCP)
      DOUBLE PRECISION LATPAR(MAXPCP,5),SIGMA(MAXPCP)

      INTEGER NLINES
      CHARACTER *50 LINE(15)

      COMMON / MENU / NLINES,LINE
      COMMON / DATA2 / NCELL,LATPAR,SIGMA,DATAST

      IF (INIT_NO_OF_PHASES().LT.14) THEN 
       NLINES=INIT_NO_OF_PHASES()+3
       LINE(1)='Phases and information:'

       DO 10 I=1,INIT_NO_OF_PHASES()
        IF (DATAST(I).EQ.0) THEN 
         PINFO=' all (no info).'
        ELSE IF(DATAST(I).EQ.1) THEN
         PINFO=' interfacial energy (sigma).'
        ELSE IF(DATAST(I).EQ.2) THEN
         PINFO=' nothing.'
        ENDIF
        PINFO=': missing: '//PINFO
        LINE(I+1)=INIT_PHASE_NAME(I)//PINFO
 10    CONTINUE
       LINE(I+1)=''
 20    LINE(I+2)='Enter whatever character to continue.'
       CALL DISP_MENU()
       READ(*,*,ERR=20) FAKE
      
      ELSE 
       NLINES=15
       LINE(1)='Phases and information:'
       DO 30 I=1,8
        IF (DATAST(I).EQ.0) THEN 
         PINFO=' all (no info).'
        ELSE IF(DATAST(I).EQ.1) THEN
         PINFO=' interfacial energy (sigma).'
        ELSE IF(DATAST(I).EQ.2) THEN
         PINFO=' nothing.'
        ENDIF
        PINFO=': missing: '//PINFO
        LINE(I)=INIT_PHASE_NAME(I)//PINFO
 30    CONTINUE
       LINE(I+1)='Enter n for the next page'
       CALL DISP_MENU()
       READ(*,*,ERR=30) FAKE

       NLINES=INIT_NO_OF_PHASES()-11
       LINE(1)='Phases and information:'
       DO 40 I=14,INIT_NO_OF_PHASES()
        IF (DATAST(I).EQ.0) THEN 
         PINFO=' all (no info).'
        ELSE IF(DATAST(I).EQ.1) THEN
         PINFO=' interfacial energy (sigma).'
        ELSE IF(DATAST(I).EQ.2) THEN
         PINFO=' nothing.'
        ENDIF
        PINFO=': missing: '//PINFO
        LINE(I-12)=INIT_PHASE_NAME(I)//PINFO
 40    CONTINUE
       LINE(I-11)=''
 50    LINE(I-10)='Enter whatever character to continue.'
       CALL DISP_MENU()
       READ(*,*,ERR=50) FAKE
      ENDIF

      END

C **********************************************************************
C
C Subroutine DISP_MENU(NLINES,LINE) displays a formatted menu placed in
C the character array LINE by the subroutine MENU_X.
C 
      SUBROUTINE DISP_MENU()
      INTEGER NLINES
      CHARACTER *50 LINE(15)
      COMMON / MENU / NLINES,LINE

      WRITE(*,60)      
      WRITE(*,70)
      WRITE(*,80)
      WRITE(*,110) LINE(1)
      WRITE(*,80)
      DO 10 I=2,NLINES
         WRITE(*,100) LINE(I)
 10      CONTINUE
      WRITE(*,80)
      WRITE(*,70)
      WRITE(*,120)
 
 60   FORMAT (30(/))
 70   FORMAT (5X,70('*'))
 80   FORMAT (5X,'*',68X,'*')
 100  FORMAT (5X,'*',9X,A,9X,'*')
 110  FORMAT (5X,5('*'),5X,A,5X,5('*'))
 120  FORMAT (5(/))
      
      END




C ****************************************************************
C Subroutine diffu 2
C calculates the mobility as proposed in Engstrom and Agren's paper.
C 
C then calculates the diffusion coefficients.

      SUBROUTINE CALC_DIFFU_II(DMAT)
      
      PARAMETER(MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      INTEGER INIT_COMPONENT_NO,ACT_COMPONENT_NO,I,K,J,L,M,N

      CHARACTER*2 ELEMENT(MAXCPT)
      DOUBLE PRECISION ENG(MAXCPT,MAXCPT),DUM
      DOUBLE PRECISION JACO(MAXCPT,MAXCPT)
      DOUBLE PRECISION DMAT(MAXCPT,MAXCPT)
      DOUBLE PRECISION MOBIL(MAXCPT)
      
      DOUBLE PRECISION TEMP,COMPO(MAXCPT)
      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT)
      DOUBLE PRECISION CBA(MAXCPT),CAVERN(MAXCPT)

      COMMON / DATA1 / TEMP,COMPO
      COMMON / TIE / CAVER,CAB,CBA,CAVERN

      DO 10 I=1,MAXCPT
         MOBIL(I)=0.0d0
 10   CONTINUE


      ELEMENT(1)='Ni'
      ELEMENT(2)='Al'
      ELEMENT(3)='Cr'
      ELEMENT(4)='Co'
      ELEMENT(5)='Mo'
      ELEMENT(6)='Ti'

C The dg for Ni as an indice

      ENG(1,1)=-287000.0D0-69.8D0*TEMP
      ENG(1,4)=ENG(1,1)
      ENG(1,5)=ENG(1,1)
      ENG(1,6)=ENG(1,1)
      ENG(1,2)=0.0D0
      ENG(1,3)=-235000.0D0-82.0D0*TEMP

C The dg for Al as an indice

      ENG(2,1)=-284000.0D0-59.83D0*TEMP
      ENG(2,2)=0.0D0
      ENG(2,3)=-235000.0D0-82.0D0*TEMP
      ENG(2,4)=ENG(2,1)
      ENG(2,5)=ENG(2,1)
      ENG(2,6)=ENG(2,1)

C The dg for Cr..

      ENG(3,1)=-287000.0D0-64.4D0*TEMP
      ENG(3,2)=0.0D0
      ENG(3,3)=-235000.0D0-82.0D0*TEMP
      ENG(3,4)=ENG(3,1)
      ENG(3,5)=ENG(3,1)
      ENG(3,6)=ENG(3,1)

C The dg for Co

      ENG(4,1)=-271000.0D0-78.98D0*TEMP
      ENG(4,2)=-272000.0D0-85.31D0*TEMP
      ENG(4,3)=-235000.0D0-82.0D0*TEMP
      ENG(4,4)=ENG(4,2)
      ENG(4,5)=ENG(4,2)
      ENG(4,6)=ENG(4,2)

C The dg fo Mo

      ENG(5,1)=-269000.0D0-77.93D0*TEMP
      ENG(5,2)=-287000.0D0-64.4D0*TEMP
      ENG(5,3)=-235000.0D0-82.0D0*TEMP
      ENG(5,4)=ENG(5,2)
      ENG(5,5)=ENG(5,2)
      ENG(5,6)=ENG(5,2)

C The dg for Ti

      ENG(6,1)=-256900.0D0-77.83D0*TEMP
      ENG(6,2)=ENG(6,1)
      ENG(6,3)=-235000.0D0-82.0D0*TEMP
      ENG(6,4)=ENG(6,1)
      ENG(6,5)=ENG(6,1)
      ENG(6,6)=ENG(6,1)

      DO 20 I=1,6

      DUM=0.0D0

      IF(ACT_COMPONENT_NO(ELEMENT(I)).EQ.0) THEN
         WRITE(*,*) 'Subroutine CALC_DIFFU_II: ',ELEMENT(I), 
     * ' is not an element of your system'
      ELSE
         DO 15 J=1,6
          IF (ACT_COMPONENT_NO(ELEMENT(J)).NE.0) THEN
          DUM=DUM+CAVER(ACT_COMPONENT_NO(ELEMENT(J)))*ENG(I,J)
          ENDIF
 15      CONTINUE
         MOBIL(ACT_COMPONENT_NO(ELEMENT(I)))=(1.0D0/(8.31451D0*TEMP))*
     * DEXP(DUM/(8.31451D0*TEMP))

         WRITE(*,*) 'Mobility for ',ELEMENT(I),' : ',
     & MOBIL(ACT_COMPONENT_NO(ELEMENT(I)))

      ENDIF

 20   CONTINUE

C We have the mobility, now the diffusion coefficients require the Hessian 
C matrix for G.

      CALL JACOMU(CAVERN,TEMP,JACO)

      DO 30 I=1,6
       DO 30 J=1,6
        DMAT(I,J)=0.0D0
        DO 25 K=1,6
           L=ACT_COMPONENT_NO(ELEMENT(I))
           M=ACT_COMPONENT_NO(ELEMENT(J))
           N=ACT_COMPONENT_NO(ELEMENT(K))
           DMAT(I,J)=DMAT(I,J)+
     &          (DIRAC(I,K)-CAVER(L))*CAVER(N)*MOBIL(N)*JACO(N,M)
 25     CONTINUE
 30   CONTINUE

      DO 40 I=1,6
         WRITE(*,*) (' D',ELEMENT(I),ELEMENT(J),': ',DMAT(I,J),J=1,6)
	 WRITE(*,*)
 40   CONTINUE

      END

C ********************************************************************
C function dirac...
C 

      DOUBLE PRECISION FUNCTION DIRAC(I,J)
      INTEGER I,J
      IF(I.EQ.J) THEN 
         DIRAC=DBLE(1)
      ELSE
         DIRAC=DBLE(0)
      ENDIF
      END

C ********************************************************************
C Subroutine DIFCO_SUB_II
C corrected version of the first one..
      SUBROUTINE DIFCO_SUB_II(XFE,XCR,XNI,TEMP,DFE,DCR,DNI,MOBILC)

      PARAMETER(MAXPCP=10,MAXTIM=20000,MAXCPT=15)

      CHARACTER*2 ELEMENT(MAXCPT)
      INTEGER ACT_COMPONENT_NO

      DOUBLE PRECISION XFE,XCR,XNI,MOBILC
      DOUBLE PRECISION DFE,DCR,DNI
      DOUBLE PRECISION Q,OMEGA
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION MOBIL(MAXCPT)
      DOUBLE PRECISION JACO(MAXCPT,MAXCPT)
      DOUBLE PRECISION DMAT(MAXCPT,MAXCPT)

      DOUBLE PRECISION CAVER(MAXCPT),CAB(MAXCPT)
      DOUBLE PRECISION CBA(MAXCPT),CAVERN(MAXCPT)

      COMMON / TIE / CAVER,CAB,CBA,CAVERN

      R=8.31451

      DO 10 I=0,MAXCPT
         MOBIL(I)=0.0d0
 10   CONTINUE

      ELEMENT(1)='Fe'
      ELEMENT(2)='Cr'
      ELEMENT(3)='Ni'
      ELEMENT(4)='C'
C Fe
      Q=35880.0D0*XFE+34410.0D0*XNI+36130.0D0*XCR
      OMEGA=3.202D-4*XFE+3.164D-4*XNI+2.364D-4*XCR
      MOBIL(ACT_COMPONENT_NO('Fe'))=OMEGA/(R*TEMP)*DEXP(-Q/TEMP)
C Ni      
      Q=35650.0D0*XFE+34600.0D0*XNI+38010.0D0*XCR
      OMEGA=1.111D-4*XFE+3.808D-4*XNI+1.542D-4*XCR
      MOBIL(ACT_COMPONENT_NO('Ni'))=OMEGA/(R*TEMP)*DEXP(-Q/TEMP)
C Cr
      Q=36100.0D0*XFE+32080.0D0*XNI+34620.0D0*XCR
      OMEGA=2.747D-4*XFE+1.117D-4*XNI+1.444D-4*XCR
      MOBIL(ACT_COMPONENT_NO('Cr'))=OMEGA/(R*TEMP)*DEXP(-Q/TEMP)

      MOBIL(ACT_COMPONENT_NO('C'))=MOBILC

      CALL JACOMU(CAVERN,TEMP,JACO)

      DO 30 I=1,6
       DO 30 J=1,6
        DMAT(I,J)=0.0D0
        DO 25 K=1,6
           L=ACT_COMPONENT_NO(ELEMENT(I))
           M=ACT_COMPONENT_NO(ELEMENT(J))
           N=ACT_COMPONENT_NO(ELEMENT(K))
           DMAT(I,J)=DMAT(I,J)+
     &          (DIRAC(I,K)-CAVER(L))*CAVER(N)*MOBIL(N)*JACO(N,M)
 25     CONTINUE
 30   CONTINUE

      END



C ********************************************************************
C FUNCTION CAPILS, given sigma, the radius of the spherical 
C particle, and the molar volume, returns the pressure to be set to add 
C the proper amount of Gibbs free energy to the precipitate.

      FUNCTION CAPILS(SIGMA,R,VMOL)
      CAPILS=(2.0d0*SIGMA*VMOL/R)*1.0d-6
      END








